import os
import platform
import tkinter as tk
import tkinter.messagebox
from tkinter import ttk
from tkinter import messagebox
from tkinter import simpledialog
from tkinter import scrolledtext
from tkinter import ttk
from websocket import create_connection
import json
import ijson
import re
import paramiko
import time
import pandas as pd
import chardet
import tkinter as tk
import shutil
import datetime
import mimetypes
from tkinter import filedialog
import shutil
import mimetypes
from tkinter import filedialog
from scp import SCPClient, SCPException
import time
import re
import stat
import tempfile
import posixpath
import threading



def create_row1(root,ip="192.168.100.17",portIndex=1, userid="root", password="toor"):
    global txtIP, cboPort, txtUID, txtPW
    lbl_ip = tk.Label(root, text="IP Address")
    lbl_ip.grid(row=0, column=0, sticky="w",padx=(10, 0))
    txtIP = tk.Entry(root)
    txtIP.insert(0, ip)
    txtIP.grid(row=0, column=1, sticky="w")

    lbl_port = tk.Label(root, text="Port")
    lbl_port.grid(row=0, column=2, sticky="w",padx=(10, 0))
    cboPort = ttk.Combobox(root, values=[9000, 9001, 9002, 9003], state='readonly')
    cboPort.current(portIndex)
    cboPort.grid(row=0, column=3, sticky="w")

    lbl_UID = tk.Label(root, text="SSH UserID")
    lbl_UID.grid(row=0, column=4, sticky="w",padx=(10, 0))
    txtUID = tk.Entry(root)
    txtUID.insert(0, userid)
    txtUID.grid(row=0, column=5, sticky="w")

    lbl_PW = tk.Label(root, text="SSH Password")
    lbl_PW.grid(row=0, column=6, sticky="w",padx=(10, 0))
    txtPW = tk.Entry(root)
    txtPW.insert(0, password)
    txtPW.grid(row=0, column=7, sticky="w")

    #return txtIP, cboPort


def create_row2(root):
    lbl_cell_id = tk.Label(root, text="Cell ID")
    lbl_cell_id.grid(row=1, column=0, sticky="w",padx=(10, 0))
    cboCellID = ttk.Combobox(root, values=['1', '2', '3'], state='readonly')
    cboCellID.grid(row=1, column=1, sticky="w")
    cboCellID.current(0)

    lbl_ue_id = tk.Label(root, text="UE ID")
    lbl_ue_id.grid(row=1, column=2, sticky="w",padx=(10, 0))
    cboUEID = ttk.Combobox(root, values=['1', '2', '3'], state='readonly')
    cboUEID.grid(row=1, column=3, sticky="w")
    cboUEID.current(0)


#def create_row3(root, txtCommand):
def create_row3(root):
    # Read the JSON file
    with open('remoteApi.txt', 'r') as f:
        data = json.load(f)

    # Create the 'Command' drop-down
    command_var = tk.StringVar()
    cboCommand = ttk.Combobox(root, textvariable=command_var)
    cboCommand['values'] = [item['message'] for item in data]
    cboCommand.current(0)  # Select the first item by default

    # Create the 'SubCommand' drop-down
    subcommand_var = tk.StringVar()
    cboSubCommand = ttk.Combobox(root, textvariable=subcommand_var)

    # Function to update the 'SubCommand' drop-down
    def update_subcommand(*args):
        message = command_var.get()
        for item in data:
            if item['message'] == message:
                cboSubCommand['values'] = item['settings']    
                item_count = len(cboSubCommand['values'])
                if item_count > 0  :
                    cboSubCommand.current(0)  # Select the first item by default after updating values
                break

    # Function to update the command string in txtCommand
    def update_command_string(*args):
        if not subcommand_var.get()   :
            cmdString = "{}".format('{"message"'+':'+'"'+command_var.get()+'"' + '}')
        else  :  
            if subcommand_var.get() != "{}" :
                cmdString = "{},{}".format('{"message"'+':'+'"'+command_var.get()+'"', subcommand_var.get()[1:-1] + ' }')
                cmdString = cmdString.replace("'", '"')
                cmdString = cmdString.replace("False", 'false')
                cmdString = cmdString.replace("True", 'true')
            else :
                cmdString = "{}".format('{"message"'+':'+'"'+command_var.get()+'"' + '}')
            
        txtCommand.delete("1.0", tk.END)  # Clear the current text
        txtCommand.insert("1.0", cmdString)  # Insert the new command string

    # Update the 'SubCommand' drop-down when the 'Command' selection changes
    command_var.trace('w', update_subcommand)
    command_var.trace('w', update_command_string)  # Update the command string when command_var changes
    subcommand_var.trace('w', update_command_string)  # Update the command string when subcommand_var changes

    # Arrange the widgets using grid (or use pack/place, depending on your layout)
    lbl_command = tk.Label(root, text="Command")
    lbl_command.grid(row=2, column=0, sticky="w",padx=(10, 0))
    cboCommand.grid(row=2, column=1, sticky="w")

    lbl_sub_command = tk.Label(root, text="SubCommand")
    lbl_sub_command.grid(row=2, column=2, sticky="w",padx=(10, 0))
    cboSubCommand.grid(row=2, column=3, columnspan=7, sticky="ew",padx=(0, 10))

    #return cboCommand, cboSubCommand  # Return these so they can be used elsewhere


def create_row4(root):
    lbl_remote_api_command = tk.Label(root, text="Remote API Command :")
    lbl_remote_api_command.grid(row=3, columnspan=6, sticky="w",padx=(10, 0))


def create_row5(root):
    global txtCommand
    txtCommand = tk.Text(root, height=3)
    txtCommand.grid(row=4, columnspan=9, sticky="nsew",padx=(10, 10))
    txtCommand.insert("1.0", '{"message":"config_get"}')



def create_row6(root):    

    btnSend = ttk.Button(root, text="Send", command=lambda: send_command())
    btnSend.grid(row=5, column=0, columnspan=9, sticky="ew", padx=(400, 400), pady=(5, 5))


def create_row7(root):
    global txtReturn
    txtReturn_frame = tk.Frame(root)
    txtReturn_frame.grid(row=6, columnspan=9, sticky="nsew", padx=(10, 10))

    scrollbar = tk.Scrollbar(txtReturn_frame)
    scrollbar.pack(side="right", fill="y")

    txtReturn = tk.Text(txtReturn_frame, height=10, yscrollcommand=scrollbar.set)
    txtReturn.pack(side="left", fill="both", expand=True)

    scrollbar.config(command=txtReturn.yview)



def create_row8(root):

    btnProcess = ttk.Button(root, text="Process", command=lambda: process_txtReturn())
    btnProcess.grid(row=7, column=0, columnspan=9, sticky="ew", padx=(400, 400), pady=(5, 5))

    

def create_row9(root):

    global tblProcess
    frame = tk.Frame(root)
    frame.grid_rowconfigure(0, weight=1)
    frame.grid_columnconfigure(0, weight=1)

    tblProcess = ttk.Treeview(frame)
    tblProcess["columns"] = ("Value")
    for col in tblProcess["columns"]:
        tblProcess.heading(col, text=col)
        tblProcess.column(col, anchor="center", minwidth=0, stretch=True)
    tblProcess.grid(row=0, column=0, sticky="nsew")

    yscrollbar = tk.Scrollbar(frame, orient=tk.VERTICAL, command=tblProcess.yview)
    yscrollbar.grid(row=0, column=1, sticky="ns")
    tblProcess.configure(yscrollcommand=yscrollbar.set)

    xscrollbar = tk.Scrollbar(frame, orient=tk.HORIZONTAL, command=tblProcess.xview)
    xscrollbar.grid(row=1, column=0, sticky="ew")
    tblProcess.configure(xscrollcommand=xscrollbar.set)

    frame.grid(row=8, columnspan=9, sticky="nsew", padx=(10, 10), pady=(0, 10))



def create_row10(root):    

    frame = tk.Frame(root,borderwidth=2, relief="groove") 
    frame.grid_rowconfigure(0, weight=1)
    frame.grid_columnconfigure(0, weight=0)

    colOffset = 0
    btnExpandAll = ttk.Button(frame, text="Expand All", width=30, command=lambda: ExpandAll(tblProcess))
    btnExpandAll.grid(row=10, column=0+colOffset, sticky="n", padx=(10, 0), pady=(5, 5))

    btnCollapseAll = ttk.Button(frame, text="Collapse All", width=30, command=lambda: CollapseAll(tblProcess))
    btnCollapseAll.grid(row=10, column=1+colOffset, sticky="n", padx=(10, 0), pady=(5, 5))

    btnExpandLevel1 = ttk.Button(frame, text="Expand Level 1", width=30, command=lambda: ExpandLevel1(tblProcess))
    btnExpandLevel1.grid(row=10, column=2+colOffset, sticky="n", padx=(10, 0), pady=(5, 5))

    frame.grid(row=10, columnspan=9, sticky="nsew", padx=(10, 10), pady=(0, 10))


def create_row11(root):    

    frame = tk.Frame(root,borderwidth=2, relief="groove") 
    frame.grid_rowconfigure(0, weight=1)
    frame.grid_columnconfigure(0, weight=0)

    colOffset = 0

    btnServiceStop = ttk.Button(frame, text="Stop LTE service", width=30, command=lambda: lteServiceStop(txtIP))
    btnServiceStop.grid(row=11, column=3+colOffset, sticky="n", padx=(10, 0), pady=(5, 5))

    btnServiceRestart = ttk.Button(frame, text="Restart LTE service", width=30, command=lambda: lteServiceRestart(txtIP))
    btnServiceRestart.grid(row=11, column=4+colOffset, sticky="n", padx=(10, 0), pady=(5, 5))

    frame.grid(row=11, columnspan=9, sticky="nsew", padx=(10, 10), pady=(0, 10))


#def create_row1_tab2(root, chkVarTxGainTxAll, chkVarTxGainTx):
def create_row1_tab2(root):

    global txtTxGain
    nested_frame = tk.Frame(root, bd=2, relief="groove")
    nested_frame.grid(row=0, column=0, columnspan=18,sticky="we", padx=(10,10), pady=(5,5))

    # i)
    lblTxGain = ttk.Label(nested_frame , text="tx_gain", width=10)
    lblTxGain.grid(row=0, column=0, sticky="w", padx=(10,10), pady=(5,5))
    chkTxGainAll = ttk.Checkbutton(nested_frame, text="", variable=chkVarTxGainAll)
    chkTxGainAll.grid(row=0, column=1, sticky="ew", padx=(10,0), pady=(5,5))

    # ii)
    txtTxGain = ttk.Spinbox(nested_frame , from_=0, to=100, width=5)
    txtTxGain.set(90)  # Set the default value
    txtTxGain.grid(row=0, column=2, sticky="ew", padx=(10,0), pady=(5,5))

    # iii)
    btnTxGain = ttk.Button(nested_frame, text="Set", command=process_btnTxGain)
    btnTxGain.grid(row=0, column=3, sticky="ew", padx=(0,10), pady=(5,5))


    for i in range(8):
        spinVarTxGain.append(tk.IntVar(value=90))  
        lblTxGain = ttk.Label(nested_frame , text="TX{}".format(i))
        lblTxGain.grid(row=0, column=4+2*i, sticky="w", padx=(10,0), pady=(5,5))
        spinTxGain = ttk.Spinbox(nested_frame, from_=0, to=90, textvariable=spinVarTxGain[i], width=5, name='txtTxGainNo{}'.format(i))
        spinTxGain.grid(row=0, column=4+2*i+1, sticky="w", padx=(0,10), pady=(5,5))



#def create_row2_tab2(root, chkVarRxGainRxAll, chkVarRxGainRx):
def create_row2_tab2(root):

    global txtRxGain
    nested_frame = tk.Frame(root, bd=2, relief="groove")
    nested_frame.grid(row=1, column=0, columnspan=18,sticky="we", padx=(10,10), pady=(5,5))

    # i)
    lblRxGain = ttk.Label(nested_frame , text="rx_gain", width=10)
    lblRxGain.grid(row=0, column=0, sticky="w", padx=(10,10), pady=(5,5))
    chkRxGainAll = ttk.Checkbutton(nested_frame, text="", variable=chkVarRxGainAll)
    chkRxGainAll.grid(row=0, column=1, sticky="ew", padx=(10,0), pady=(5,5))

    # ii)
    txtRxGain = ttk.Spinbox(nested_frame , from_=0, to=100, width=5)
    txtRxGain.set(60)  # Set the default value
    txtRxGain.grid(row=0, column=2, sticky="ew", padx=(10,0), pady=(5,5))

    # iii)
    btnRxGain = ttk.Button(nested_frame , text="Set", command = process_btnRxGain)
    btnRxGain.grid(row=0, column=3, sticky="ew", padx=(0,10), pady=(5,5))

    for i in range(8):
        spinVarRxGain.append(tk.IntVar(value=60))  
        lblRxGain = ttk.Label(nested_frame , text="TX{}".format(i))
        lblRxGain.grid(row=0, column=4+2*i, sticky="w", padx=(10,0), pady=(5,5))
        spinRxGain = ttk.Spinbox(nested_frame, from_=0, to=60, textvariable=spinVarRxGain[i], width=5, name='txtRxGainNo{}'.format(i))
        spinRxGain.grid(row=0, column=4+2*i+1, sticky="w", padx=(0,10), pady=(5,5))


#def create_row3_tab2(root, chkVarForceDlSchedule, chkVarPdschFixedRbAlloc):
def create_row3_tab2(root):    

    global txtForceDlScheduleCells, txtForceDlScheduleMCS , txtForceDlScheduleRbStart, txtForceDlScheduleRbN
    
    #nested_frame = tk.Frame(root)
    nested_frame = tk.Frame(root, bd=2, relief="groove")
    nested_frame.grid(row=2, column=0, columnspan=14,sticky="we", padx=(10,10), pady=(5,5)) 

    lblForceDlScheduleCells = ttk.Label(nested_frame, text="cells", width=10)
    lblForceDlScheduleCells.grid(row=0, column=0, sticky="w", padx=(10,10), pady=(5,5))

    txtForceDlScheduleCells = ttk.Spinbox(nested_frame, from_=0, to=100, width = 5)
    txtForceDlScheduleCells.set(1)  # Set the default value
    txtForceDlScheduleCells.grid(row=0, column=1, sticky="ew", padx=(10,0), pady=(5,5))

    btnPhyDL = ttk.Button(nested_frame, text="Set", command=process_btnPhyDL)
    btnPhyDL.grid(row=0, column=2, sticky="ew", padx=(0,10), pady=(5,5))

    chkForceDlSchedule = ttk.Checkbutton(nested_frame, text="force_dl_schedule", variable=chkVarForceDlSchedule)
    chkForceDlSchedule.grid(row=0, column=3, sticky="w", padx=(10,10), pady=(5,5))

    chkPdschFixedRbAlloc= ttk.Checkbutton(nested_frame, text="fixed_rb_alloc", variable=chkVarPdschFixedRbAlloc)
    chkPdschFixedRbAlloc.grid(row=0, column=4, sticky="w", padx=(10,10), pady=(5,5))

    lblForceDlScheduleMCS = ttk.Label(nested_frame, text="MCS")
    lblForceDlScheduleMCS.grid(row=0, column=5, sticky="w", padx=(10,10), pady=(5,5))

    txtForceDlScheduleMCS = ttk.Spinbox(nested_frame, from_=0, to=28, width = 5)
    txtForceDlScheduleMCS.set(5)  # Set the default value
    txtForceDlScheduleMCS.grid(row=0, column=6, sticky="ew", padx=(10,0), pady=(5,5))

    lblForceDlScheduleRbStart = ttk.Label(nested_frame, text="Start RB")
    lblForceDlScheduleRbStart.grid(row=0, column=7, sticky="w", padx=(10,10), pady=(5,5))

    txtForceDlScheduleRbStart = ttk.Spinbox(nested_frame, from_=0, to=273, width = 5)
    txtForceDlScheduleRbStart.set(0)  # Set the default value
    txtForceDlScheduleRbStart.grid(row=0, column=8, sticky="ew", padx=(10,0), pady=(5,5))

    lblForceDlScheduleRbN = ttk.Label(nested_frame , text="N RB")
    lblForceDlScheduleRbN.grid(row=0, column=9, sticky="w", padx=(10,10), pady=(5,5))

    txtForceDlScheduleRbN = ttk.Spinbox(nested_frame, from_=1, to=273, width = 5)
    txtForceDlScheduleRbN.set(51)  # Set the default value
    txtForceDlScheduleRbN.grid(row=0, column=10, sticky="ew", padx=(10,0), pady=(5,5))



# def create_row4_tab2(root, chkVarForceFullBsr, chkVarPuschFixedRbAlloc):
def create_row4_tab2(root):    
    
    global txtForceFullBsrCells, txtForceFullBsrMCS , txtForceFullBsrRbStart, txtForceFullBsrRbN
    #nested_frame = tk.Frame(root)
    nested_frame = tk.Frame(root, bd=2, relief="groove")
    nested_frame.grid(row=3, column=0, columnspan=14,sticky="we", padx=(10,10), pady=(5,5)) 

    lblForceFullBsrCells = ttk.Label(nested_frame, text="cells", width=10)
    lblForceFullBsrCells.grid(row=0, column=0, sticky="w", padx=(10,10), pady=(5,5))

    txtForceFullBsrCells = ttk.Spinbox(nested_frame, from_=0, to=100, width = 5)
    txtForceFullBsrCells.set(1)  # Set the default value
    txtForceFullBsrCells.grid(row=0, column=1, sticky="ew", padx=(10,0), pady=(5,5))

    btnPhyUL = ttk.Button(nested_frame, text="Set", command=process_btnPhyUL)
    btnPhyUL.grid(row=0, column=2, sticky="ew", padx=(0,10), pady=(5,5))

    chkForceFullBsr = ttk.Checkbutton(nested_frame, text="force_full_bsr", variable=chkVarForceFullBsr)
    chkForceFullBsr.grid(row=0, column=3, sticky="w", padx=(10,10), pady=(5,5))

    chkPuschFixedRbAlloc= ttk.Checkbutton(nested_frame, text="fixed_rb_alloc", variable=chkVarPuschFixedRbAlloc)
    chkPuschFixedRbAlloc.grid(row=0, column=4, sticky="w", padx=(10,10), pady=(5,5))

    lblForceFullBsrMCS = ttk.Label(nested_frame, text="MCS")
    lblForceFullBsrMCS.grid(row=0, column=5, sticky="w", padx=(10,10), pady=(5,5))

    txtForceFullBsrMCS = ttk.Spinbox(nested_frame, from_=0, to=100, width = 5)
    txtForceFullBsrMCS.set(5)  # Set the default value
    txtForceFullBsrMCS.grid(row=0, column=6, sticky="ew", padx=(10,0), pady=(5,5))

    lblForceFullBsrRbStart = ttk.Label(nested_frame, text="Start RB")
    lblForceFullBsrRbStart.grid(row=0, column=7, sticky="w", padx=(10,10), pady=(5,5))

    txtForceFullBsrRbStart = ttk.Spinbox(nested_frame, from_=0, to=273, width = 5)
    txtForceFullBsrRbStart.set(0)  # Set the default value
    txtForceFullBsrRbStart.grid(row=0, column=8, sticky="ew", padx=(10,0), pady=(5,5))

    lblForceFullBsrRbN = ttk.Label(nested_frame , text="N RB")
    lblForceFullBsrRbN.grid(row=0, column=9, sticky="w", padx=(10,10), pady=(5,5))

    txtForceFullBsrRbN = ttk.Spinbox(nested_frame, from_=1, to=273, width = 5)
    txtForceFullBsrRbN.set(51)  # Set the default value
    txtForceFullBsrRbN.grid(row=0, column=10, sticky="ew", padx=(10,0), pady=(5,5))


def create_row5_tab2(root):
    
    global txtInactivityTimer, txtInactivityTimerCells
    #nested_frame = tk.Frame(root)
    nested_frame = tk.Frame(root, bd=2, relief="groove")
    nested_frame.grid(row=4, column=0, columnspan=14,sticky="we", padx=(10,10), pady=(5,5)) 

    lblInactivityTimerCells = ttk.Label(nested_frame, text="cells", width=10)
    lblInactivityTimerCells.grid(row=0, column=0, sticky="w", padx=(10,10), pady=(5,5))

    txtInactivityTimerCells = ttk.Spinbox(nested_frame, from_=0, to=100, width = 5)
    txtInactivityTimerCells.set(1)  # Set the default value
    txtInactivityTimerCells.grid(row=0, column=1, sticky="ew", padx=(10,0), pady=(5,5))

    lblInactivityTimer = ttk.Label(nested_frame, text="Inactivity Timer", width=15)
    lblInactivityTimer.grid(row=0, column=2, sticky="e", padx=(30,0), pady=(5,5))

    txtInactivityTimer = ttk.Spinbox(nested_frame, from_= 0, to = 600000, width = 10, increment=1000)
    txtInactivityTimer.set(300000)  # Set the default value
    txtInactivityTimer.grid(row=0, column=3, sticky="ew", padx=(0,0), pady=(5,5))

    btnInactivityTimer = ttk.Button(nested_frame, text="Set",command=process_btnInactivityTimer)
    btnInactivityTimer.grid(row=0, column=4, sticky="ew", padx=(0,10), pady=(5,5))



def create_row6_tab2(root):    
    
    # Configure the root's grid to expand horizontally
    root.grid_columnconfigure(0, weight=1)

    nested_frame = tk.Frame(root)
    nested_frame.grid(row=5, column=0, columnspan=14, sticky="ew") # make the frame expand to fill its grid cell in the horizontal direction

    # Configure the nested_frame's grid to expand horizontally
    nested_frame.grid_columnconfigure(0, weight=1)

    btnUpdateLog = ttk.Button(nested_frame, text="Update Log", command=lambda: process_LogUpdate())
    btnUpdateLog.grid(row=0, column=6) # the button is placed in the center of the frame
    btnClearLog = ttk.Button(nested_frame, text="Clear Log", command=lambda: process_LogClear())
    btnClearLog.grid(row=0, column=7) # the button is placed in the center of the frame

    # Add padding around the button to center it in the frame
    for i in range(1, 14):
        nested_frame.grid_columnconfigure(i, weight=1)


def create_row7_tab2(root):
    
    global tblLogUpdate
    nested_frame = tk.Frame(root, bd=2, relief="groove")
    nested_frame.grid(row=6, column=0, columnspan=14, sticky="nsew", padx=(10,10), pady=(5,5))
    nested_frame.grid_rowconfigure(0, weight=1)
    nested_frame.grid_columnconfigure(0, weight=1)

    # Define the columns for the table
    columns = ("layer", "dir", "ue_id", "cell", "data")

    tblLogUpdate = ttk.Treeview(nested_frame, columns=columns, show="headings")
    
    for col in columns[:-1]:  # Exclude the last column ("data")
        tblLogUpdate.heading(col, text=col)
        tblLogUpdate.column(col, anchor="center", width=100, stretch=False)

    # For the last column ("data"), allow it to stretch to fill the remaining space
    tblLogUpdate.heading(columns[-1], text=columns[-1])
    tblLogUpdate.column(columns[-1], anchor="center", minwidth=0, stretch=True)

    tblLogUpdate.grid(row=0, column=0, sticky="nsew", padx=(10,0), pady=(10,10))

    yscrollbar = tk.Scrollbar(nested_frame, orient=tk.VERTICAL, command=tblLogUpdate.yview)
    yscrollbar.grid(row=0, column=1, sticky="ns")
    tblLogUpdate.configure(yscrollcommand=yscrollbar.set)




def create_row1_tabUEsim(root, ip = "192.168.100.15", portIndex=2, userid="root", password="toor"):

    global txtIP_uesim, cboPort_uesim,txtUID_Uesim, txtPW_Uesim

    gridline = 0
    frame_ip = tk.Frame(root, highlightthickness=gridline, highlightbackground="black")
    frame_ip.grid(row=0, column=0, sticky="w", padx=(10, 0))
    lbl_ip_uesim = tk.Label(frame_ip, text="IP Address")
    lbl_ip_uesim.pack(side=tk.LEFT)
    txtIP_uesim = tk.Entry(frame_ip)
    txtIP_uesim.insert(0, ip)
    txtIP_uesim.pack(side=tk.LEFT)

    frame_port = tk.Frame(root, highlightthickness=gridline, highlightbackground="black")
    frame_port.grid(row=0, column=1, sticky="w")
    lbl_port_uesim = tk.Label(frame_port, text="Port")
    lbl_port_uesim.pack(side=tk.LEFT)
    cboPort_uesim = ttk.Combobox(frame_port, values=[9000, 9001, 9002, 9003], state='readonly')
    cboPort_uesim.current(portIndex)
    cboPort_uesim.pack(side=tk.LEFT)

    frame_uid = tk.Frame(root, highlightthickness=gridline, highlightbackground="black")
    frame_uid.grid(row=0, column=2, sticky="w")
    lbl_UID_UEsim = tk.Label(frame_uid, text="SSH UserID")
    lbl_UID_UEsim.pack(side=tk.LEFT)
    txtUID_Uesim = tk.Entry(frame_uid)
    txtUID_Uesim.insert(0, userid)
    txtUID_Uesim.pack(side=tk.LEFT)

    frame_pw = tk.Frame(root, highlightthickness=gridline, highlightbackground="black")
    frame_pw.grid(row=0, column=3, sticky="w")
    lbl_PW_UEsim = tk.Label(frame_pw, text="SSH Password")
    lbl_PW_UEsim.pack(side=tk.LEFT)
    txtPW_Uesim = tk.Entry(frame_pw)
    txtPW_Uesim.insert(0, password)
    txtPW_Uesim.pack(side=tk.LEFT)



def create_row2_tabUEsim(root):

    lbl_cell_id_uesim = tk.Label(root, text="Cell ID")
    lbl_cell_id_uesim.grid(row=1, column=0, sticky="w",padx=(10, 0))
    cboCellID_uesim = ttk.Combobox(root, values=['1', '2', '3'], state='readonly')
    cboCellID_uesim.grid(row=1, column=1, sticky="w")
    cboCellID_uesim.current(0)

    lbl_ue_id_uesim = tk.Label(root, text="UE ID")
    lbl_ue_id_uesim.grid(row=1, column=2, sticky="w",padx=(10, 0))
    cboUEID_uesim = ttk.Combobox(root, values=['1', '2', '3'], state='readonly')
    cboUEID_uesim.grid(row=1, column=3, sticky="w")
    cboUEID_uesim.current(0)


def create_row3_tabUEsim(root):

    global cboCommand_uesim, cboSubCommand_uesim
    # Read the JSON file
    with open('remoteApi_UEsim.txt', 'r') as f:
        data = json.load(f)

    # Create the 'Command' drop-down
    command_var_uesim = tk.StringVar()
    cboCommand_uesim = ttk.Combobox(root, textvariable=command_var_uesim)
    cboCommand_uesim['values'] = [item['message'] for item in data]
    cboCommand_uesim.current(0)  # Select the first item by default

    # Create the 'SubCommand' drop-down
    subcommand_var_uesim = tk.StringVar()
    cboSubCommand_uesim = ttk.Combobox(root, textvariable=subcommand_var_uesim, width = 70)

    # Function to update the 'SubCommand' drop-down
    def update_subcommand(*args):
        message = command_var_uesim.get()
        for item in data:
            if item['message'] == message:
                cboSubCommand_uesim['values'] = item['settings']    
                item_count = len(cboSubCommand_uesim['values'])
                if item_count > 0  :
                    cboSubCommand_uesim.current(0)  # Select the first item by default after updating values
                break

    # Function to update the command string in txtCommand
    def update_command_string(*args):
        if not subcommand_var_uesim.get()   :
            cmdString = "{}".format('{"message"'+':'+'"'+command_var_uesim.get()+'"' + '}')
        else  :  
            if subcommand_var_uesim.get() != "{}" :
                cmdString = "{},{}".format('{"message"'+':'+'"'+command_var_uesim.get()+'"', subcommand_var_uesim.get()[1:-1] + ' }')
                cmdString = cmdString.replace("'", '"')
                cmdString = cmdString.replace("False", 'false')
                cmdString = cmdString.replace("True", 'true')
            else :
                cmdString = "{}".format('{"message"'+':'+'"'+command_var_uesim.get()+'"' + '}')
            
        txtCommand_uesim.delete("1.0", tk.END)  # Clear the current text
        txtCommand_uesim.insert("1.0", cmdString)  # Insert the new command string

    # Update the 'SubCommand' drop-down when the 'Command' selection changes
    command_var_uesim.trace('w', update_subcommand)
    command_var_uesim.trace('w', update_command_string)  # Update the command string when command_var changes
    subcommand_var_uesim.trace('w', update_command_string)  # Update the command string when subcommand_var changes

    # Arrange the widgets using grid (or use pack/place, depending on your layout)
    lbl_command_uesim = tk.Label(root, text="Command")
    lbl_command_uesim.grid(row=2, column=0, sticky="w",padx=(10, 0))
    cboCommand_uesim.grid(row=2, column=1, sticky="w")

    lbl_sub_command_uesim = tk.Label(root, text="SubCommand")
    lbl_sub_command_uesim.grid(row=2, column=2, sticky="w",padx=(10, 0))
    cboSubCommand_uesim.grid(row=2, column=3, sticky="w", padx=(0, 0))


def create_row4_tabUEsim(root):

    global txtTxGain_uesim
    nested_frame = tk.Frame(root, bd=2, relief="groove")
    nested_frame.grid(row=4, column=0, columnspan=18,sticky="we", padx=(10,10), pady=(15,5))

    # i)
    lblTxGain = ttk.Label(nested_frame , text="tx_gain", width=10)
    lblTxGain.grid(row=0, column=0, sticky="w", padx=(10,10), pady=(5,5))
    chkTxGainAll_uesim = ttk.Checkbutton(nested_frame, text="", variable=chkVarTxGainAll_uesim)
    chkTxGainAll_uesim.grid(row=0, column=1, sticky="ew", padx=(10,0), pady=(5,5))

    # ii)
    txtTxGain_uesim = ttk.Spinbox(nested_frame , from_=0, to=100, width=5)
    txtTxGain_uesim.set(90)  # Set the default value
    txtTxGain_uesim.grid(row=0, column=2, sticky="ew", padx=(10,0), pady=(5,5))

    # iii)
    btnTxGain_uesim = ttk.Button(nested_frame, text="Set", command=process_btnTxGain_uesim)
    btnTxGain_uesim.grid(row=0, column=3, sticky="ew", padx=(0,10), pady=(5,5))


    for i in range(8):
        spinVarTxGain_uesim.append(tk.IntVar(value=90))  
        lblTxGain = ttk.Label(nested_frame , text="TX{}".format(i))
        lblTxGain.grid(row=0, column=4+2*i, sticky="w", padx=(10,0), pady=(5,5))
        spinTxGain_uesim = ttk.Spinbox(nested_frame, from_=0, to=90, textvariable=spinVarTxGain_uesim[i], width=5, name='txtTxGainNo_uesim{}'.format(i))
        spinTxGain_uesim.grid(row=0, column=4+2*i+1, sticky="w", padx=(0,10), pady=(5,5))


def create_row5_tabUEsim(root):

    global txtRxGain_uesim
    nested_frame = tk.Frame(root, bd=2, relief="groove")
    nested_frame.grid(row=5, column=0, columnspan=18,sticky="we", padx=(10,10), pady=(5,5))

    # i)
    lblRxGain = ttk.Label(nested_frame , text="rx_gain", width=10)
    lblRxGain.grid(row=0, column=0, sticky="w", padx=(10,10), pady=(5,5))
    chkRxGainAll_uesim = ttk.Checkbutton(nested_frame, text="", variable=chkVarRxGainAll_uesim)
    chkRxGainAll_uesim.grid(row=0, column=1, sticky="ew", padx=(10,0), pady=(5,5))

    # ii)
    txtRxGain_uesim = ttk.Spinbox(nested_frame , from_=0, to=100, width=5)
    txtRxGain_uesim.set(60)  # Set the default value
    txtRxGain_uesim.grid(row=0, column=2, sticky="ew", padx=(10,0), pady=(5,5))

    # iii)
    btnRxGain_uesim = ttk.Button(nested_frame, text="Set", command=process_btnRxGain_uesim)
    btnRxGain_uesim.grid(row=0, column=3, sticky="ew", padx=(0,10), pady=(5,5))


    for i in range(8):
        spinVarRxGain_uesim.append(tk.IntVar(value=60))  
        lblRxGain = ttk.Label(nested_frame , text="RX{}".format(i))
        lblRxGain.grid(row=0, column=4+2*i, sticky="w", padx=(10,0), pady=(5,5))
        spinRxGain_uesim = ttk.Spinbox(nested_frame, from_=0, to=90, textvariable=spinVarRxGain_uesim[i], width=5, name='txtRxGainNo_uesim{}'.format(i))
        spinRxGain_uesim.grid(row=0, column=4+2*i+1, sticky="w", padx=(0,10), pady=(5,5))


# create the buttons for Frequently used Functions
def create_row6_tabUEsim(root):

    nested_frame = tk.Frame(root, bd=2, relief="groove")
    nested_frame.grid(row=6, column=0, columnspan=18,sticky="we", padx=(10,10), pady=(5,5))

    title = tk.Label(nested_frame, text="Frequently Used Functions")
    title.grid(row=0, column=0, sticky='w', padx=(10,10), pady=(5,5))

    btnPowerOn_uesim = ttk.Button(nested_frame, text="Power On", command=lambda: process_btnPowerOn_uesim())
    btnPowerOn_uesim.grid(row=0, column=1, sticky='w', padx=(10,10), pady=(5,5))
    
    btnPowerOff_uesim = ttk.Button(nested_frame, text="Power Off", command=lambda: process_btnPowerOff_uesim())
    btnPowerOff_uesim.grid(row=0, column=2, sticky='w', padx=(10,10), pady=(5,5))


# create the label for 'Remote API Command'
def create_row7_tabUEsim(root):
    lbl_remote_api_command = tk.Label(root, text="Remote API Command :")
    lbl_remote_api_command.grid(row=7, columnspan=6, sticky="w",padx=(10, 0))


# create the textbox for 'Command'
def create_row8_tabUEsim(root):
    global txtCommand_uesim
    txtCommand_uesim = tk.Text(root, height=3)
    txtCommand_uesim.grid(row=8, columnspan=6, sticky="nsew",padx=(10, 10))
    txtCommand_uesim.insert("1.0", '{"message":"config_get"}')


# create the button for 'Send'
def create_row9_tabUEsim(root):    

    btnSend_uesim = ttk.Button(root, text="Send", command=lambda: send_command_uesim())
    btnSend_uesim.grid(row=9, column=0, columnspan=6, sticky="ew", padx=(400, 400), pady=(5, 5))


# create the Textbox for 'Return'
def create_row10_tabUEsim(root):

    global txtReturn_uesim
    txtReturn_frame_uesim = tk.Frame(root)
    txtReturn_frame_uesim.grid(row=10, columnspan=6, sticky="nsew", padx=(10, 10), pady=(0, 10))

    scrollbar_uesim = tk.Scrollbar(txtReturn_frame_uesim)
    scrollbar_uesim.pack(side="right", fill="y")

    txtReturn_uesim = tk.Text(txtReturn_frame_uesim, height=10, yscrollcommand=scrollbar_uesim.set)
    txtReturn_uesim.pack(side="left", fill="both", expand=True)

    scrollbar_uesim.config(command=txtReturn_uesim.yview)    


def create_row11_tabUEsim(root):

    nested_frame = tk.Frame(root, bd=2, relief="groove")
    nested_frame.grid(row=11, column=0, columnspan=18,sticky="we", padx=(10,10), pady=(5,5))

    #title = tk.Label(nested_frame, text="Frequently Used Functions")
    #title.grid(row=0, column=0, sticky='w', padx=(10,10), pady=(5,5))

    btnServiceStop_uesim = ttk.Button(nested_frame, text="Stop LTE Service", command=lambda: lteServiceStop_uesim(txtIP_uesim))
    btnServiceStop_uesim.grid(row=0, column=0, sticky='w', padx=(10,10), pady=(5,5))

    btnServiceRestart_uesim = ttk.Button(nested_frame, text="Restart LTE Service", command=lambda: lteServiceRestart_uesim(txtIP_uesim))
    btnServiceRestart_uesim.grid(row=0, column=1, sticky='w', padx=(10,10), pady=(5,5))

# create the boundary frames on the tabFiles
def create_frame_tabFiles(root):
    # Create PanedWindow for vertical frames
    panedwindow = tk.PanedWindow(root, orient='horizontal')
    panedwindow.pack(fill='both', expand=True)

    # Create the frames
    frameLeft = ttk.Frame(panedwindow, relief='groove', borderwidth=1)
    frameMiddle = ttk.Frame(panedwindow, relief='groove', borderwidth=1)
    frameRight = ttk.Frame(panedwindow, relief='groove', borderwidth=1)

    # Add the frames to the PanedWindow
    panedwindow.add(frameLeft, stretch='always')
    panedwindow.add(frameMiddle)
    panedwindow.add(frameRight, stretch='always')

    # Set the width of frameMiddle to 100 pixels
    frameMiddle.config(width=100)

    # Add buttons to frameMiddle
    btnDownload = ttk.Button(frameMiddle, text='<-Download', command=lambda: process_Download(fb, fbSCP))
    btnUpload = ttk.Button(frameMiddle, text='Upload->',command=lambda:process_Upload(fb, fbSCP))

    # Calculate the vertical center position for the buttons
    btnDownload.place(relx=0.5, rely=0.45, anchor='center')
    btnUpload.place(relx=0.5, rely=0.55, anchor='center')


    return frameLeft, frameRight


# create the boundary frames on the tabFiles
def create_frame_tabFiles_UEsim(root):
    # Create PanedWindow for vertical frames
    panedwindow = tk.PanedWindow(root, orient='horizontal')
    panedwindow.pack(fill='both', expand=True)

    # Create the frames
    frameLeft = ttk.Frame(panedwindow, relief='groove', borderwidth=1)
    frameMiddle = ttk.Frame(panedwindow, relief='groove', borderwidth=1)
    frameRight = ttk.Frame(panedwindow, relief='groove', borderwidth=1)

    # Add the frames to the PanedWindow
    panedwindow.add(frameLeft, stretch='always')
    panedwindow.add(frameMiddle)
    panedwindow.add(frameRight, stretch='always')

    # Set the width of frameMiddle to 100 pixels
    frameMiddle.config(width=100)

    # Add buttons to frameMiddle
    btnDownload_UEsim = ttk.Button(frameMiddle, text='<-Download', command=lambda: process_Download(fb_UEsim, fbSCP_UEsim))
    btnUpload_UEsim = ttk.Button(frameMiddle, text='Upload->',command=lambda:process_Upload(fb_UEsim, fbSCP_UEsim))

    # Calculate the vertical center position for the buttons
    btnDownload_UEsim.place(relx=0.5, rely=0.45, anchor='center')
    btnUpload_UEsim.place(relx=0.5, rely=0.55, anchor='center')


    return frameLeft, frameRight

# create the boundary frames on the tabFiles
def create_frame_tabScreen_Callbox(root):
    # Create PanedWindow for vertical frames
    panedwindow = tk.PanedWindow(root, orient='horizontal')
    panedwindow.pack(fill='both', expand=True)

    # Create the frames
    frame = ttk.Frame(panedwindow, relief='groove', borderwidth=1)

    # Add the frames to the PanedWindow
    panedwindow.add(frame, stretch='always')


    return frame


# define Class for FileBrowser for local Disk
class FileBrowser(tk.Frame):

    def __init__(self, master=None, path='C:\\', root_directory='C:\\'):
        super().__init__(master)
        self.path = path
        self.root_directory = root_directory  # Store root_directory as an attribute
        self.selectedFile = None
        self.pack(fill='both', expand=True)

        self.paths_to_copy = []

        # Check the operating system.
        if platform.system() == 'Windows':
            self.OS = 'Windows'
        elif platform.system() == 'Linux':
            self.OS = 'Linux'
            self.path = os.path.expanduser('~')  # Expand the '~' to the full path of the home directory
            self.root_directory = '/root'
        else:
            self.OS = 'Unknown'

        self.create_widgets()
        self.update_file_list()


    # This function(method) sets up all the necessary graphical user interface (GUI) components, also known as 
    # "widgets", for the file browser application.
    #
    def create_widgets(self):

        # Load the icons
        self.folder_icon = tk.PhotoImage(file="icon_dir.png")
        self.file_icon = tk.PhotoImage(file="icon_file.png")

        # Create a Menu
        self.popup_menu = tk.Menu(self, tearoff=0)

        # Add commands to the menu
        self.popup_menu.add_command(label="Rename", command=self.rename_file)
        self.popup_menu.add_command(label="Copy", command=self.copy_file)
        self.popup_menu.add_command(label="Paste", command=self.paste_file)
        self.popup_menu.add_command(label="Delete", command=self.delete_file)
        self.popup_menu.add_command(label="Create Directory", command=self.create_dir)
        self.popup_menu.add_separator()
        self.popup_menu.add_command(label="Open File", command=self.open_with_simple_notepad)
        self.popup_menu.add_separator()
        self.popup_menu.add_command(label="Refresh", command=self.update_file_list)

        self.navigation_frame = tk.Frame(self)  # Frame to hold the Entry and Button
        self.navigation_frame.pack(fill='x')
        self.directory = tk.StringVar(value=self.path)

        self.entry = ttk.Entry(self.navigation_frame, textvariable=self.directory)
        self.button = ttk.Button(self.navigation_frame, text="Navigate", command=self.update_file_list)

        self.entry.pack(side='left', fill='x', padx=[5,0], pady=[5,5], expand=True)
        self.button.pack(side='right',padx=[5,5])

        # Bind the Enter key to the update_file_list function
        self.entry.bind('<Return>', lambda event: self.update_file_list())

        # Creating button frame
        self.button_frame = tk.Frame(self)
        self.button_frame.pack(fill='x')

        self.rename_button = ttk.Button(self.button_frame, text="Rename", command=self.rename_file)
        self.copy_button = ttk.Button(self.button_frame, text="Copy", command=self.copy_file)
        self.paste_button = ttk.Button(self.button_frame, text="Paste", command=self.paste_file)
        self.delete_button = ttk.Button(self.button_frame, text="Delete", command=self.delete_file)
        self.create_dir_button = ttk.Button(self.button_frame, text="Create Dir", command=self.create_dir)

        self.rename_button.pack(side='left', padx=[5,0], pady=[0,5])
        self.copy_button.pack(side='left', pady=[0,5])
        self.paste_button.pack(side='left', pady=[0,5])
        self.delete_button.pack(side='left', pady=[0,5])
        self.create_dir_button.pack(side='left', padx=[0,5], pady=[0,5])

        self.file_frame = tk.Frame(self)  # Frame to hold the Treeview and Scrollbar
        self.file_frame.pack(fill='both', expand=True)

        self.file_list = ttk.Treeview(self.file_frame, columns=('fullpath', 'type', 'size'), show='tree headings')  # Note the change here
        self.file_list.column("#1", width=100)
        self.file_list.column("#2", width=150)
        self.file_list.column("#3", width=100)
        self.file_list.heading("#0", text="File Name")
        self.file_list.heading("#1", text="Size (bytes)")
        self.file_list.heading("#2", text="Modified Time")
        self.file_list.heading("#3", text="File Type")
        self.file_list.bind('<Double-1>', self.navigate)  # Bind the function navigate to double click event
        self.file_list.tag_configure('parent_directory', font=('TkDefaultFont', 14, 'bold'))
        self.file_list.bind("<Button-3>", self.show_popup_menu)  # Button-3 is right-click

        # Add binding for 'Ctrl + C' to copy_file
        self.file_list.bind('<Control-c>', self.copy_file)

        # Add binding for 'Ctrl + V' to paste_file
        self.file_list.bind('<Control-v>', self.paste_file)

        # Add binding for 'File Selection' to paste_file
        self.file_list.bind('<<TreeviewSelect>>', self.select_file)

        self.scrollbar = ttk.Scrollbar(self.file_frame, orient="vertical", command=self.file_list.yview)
        self.file_list.configure(yscrollcommand=self.scrollbar.set)

        self.file_list.pack(side='left', fill='both', expand=True, padx=[5,0], pady=[0,5]) # Use side option to pack Treeview and Scrollbar horizontally
        self.scrollbar.pack(side='right', fill='y')


    # assign the selected file path and name to the public variable selectedFile
    def select_file(self, event):
        selected = self.file_list.selection()  # Get the selected items
        if selected:
            item = self.file_list.item(selected[0])  # Get the first selected item
            self.selectedFile = f"{self.path}\{item['text']}"  # Update the 'selectedFile' attribute
        print(self.selectedFile)    
        print(self.path) 


    def rename_file(self):
        # Get selected file or directory
        selected_item = self.file_list.selection()[0]
        selected_item_text = self.file_list.item(selected_item, "text")

        # Function to handle renaming
        def rename(event=None):
            new_name = new_name_var.get()
            old_path = os.path.join(self.path, selected_item_text)
            new_path = os.path.join(self.path, new_name)

            try:
                os.rename(old_path, new_path)
                self.update_file_list()
            except Exception as e:
                print(f"Error renaming file: {e}")
            finally:
                # Destroy the Entry widget when done
                new_name_entry.destroy()

        # Function to handle the ESC key
        def handle_esc(event=None):
            new_name_entry.destroy()

        # Get the position of the selected item in the treeview
        x, y, _, _ = self.file_list.bbox(selected_item)

        # Create an Entry widget at the position of the selected item
        new_name_var = tk.StringVar()
        new_name_entry = ttk.Entry(self.file_list, textvariable=new_name_var, width=len(selected_item_text))
        new_name_entry.place(x=x, y=y)
        new_name_var.set(selected_item_text)
        new_name_entry.focus()

        # Bind the Enter key to the rename function
        new_name_entry.bind('<Return>', rename)

        # Bind the ESC key to the handle_esc function
        new_name_entry.bind('<Escape>', handle_esc)
    


    # This function is designed to copy one or more selected files within the FileBrowser application.
    # 
    def copy_file(self, event=None):
        # Get selected files
        for selected_item in self.file_list.selection():
            selected_item_text = self.file_list.item(selected_item, "text")
            full_path = os.path.join(self.path, selected_item_text)

            # If the selected item is a file, add its path to the list
            if os.path.isfile(full_path):
                self.paths_to_copy.append(full_path)
            else:
                messagebox.showerror("Error", "Please select only files to copy.")


    # This function is designed to paste the files that have been previously selected for copying in the FileBrowser
    # application.
    def paste_file(self, event=None):
        # If there are files to copy
        if self.paths_to_copy:
            try:
                for path_to_copy in self.paths_to_copy:
                    # Get the base name of the file to copy
                    file_name = os.path.basename(path_to_copy)
                    # Compute the full path of the new file
                    new_file_path = os.path.join(self.path, file_name)
                    
                    # If a file with the same name already exists in the destination directory
                    if os.path.exists(new_file_path):
                        # Split the file name into name and extension
                        name, ext = os.path.splitext(file_name)
                        # Append '-Copy' to the name and reassemble the file name
                        new_file_name = f"{name}-Copy{ext}"
                        # Compute the full path of the new file
                        new_file_path = os.path.join(self.path, new_file_name)
                    
                    # Copy the file
                    shutil.copy2(path_to_copy, new_file_path)
                
                # Clear the list of files to copy
                self.paths_to_copy = []
                self.update_file_list()
            except Exception as e:
                messagebox.showerror("Error", f"Failed to paste files: {e}")
        else:
            messagebox.showerror("Error", "No files to paste.")


    # This function is responsible for deleting selected files and directories in the FileBrowser application.
    #
    def delete_file(self):
        # Get selected items
        selected_items = self.file_list.selection()

        if not selected_items:
            messagebox.showerror("Error", "No file or directory selected.")
            return

        response = messagebox.askokcancel("Confirm delete", "Are you sure you want to delete the selected items?")

        if response:
            for selected_item in selected_items:
                selected_item_text = self.file_list.item(selected_item, "text")
                full_path = os.path.join(self.path, selected_item_text)

                try:
                    # If the selected item is a file, delete it
                    if os.path.isfile(full_path):
                        os.remove(full_path)
                    # If the selected item is a directory, delete it and all its contents
                    elif os.path.isdir(full_path):
                        # Check if directory is not empty
                        if os.listdir(full_path):
                            response = messagebox.askokcancel("Directory not empty", 
                                                            "This directory is not empty. All the files within the directory will be deleted as well. Do you want to delete?")
                            if response:
                                shutil.rmtree(full_path)
                            else:
                                continue
                        else:
                            shutil.rmtree(full_path)
                    self.update_file_list()
                except Exception as e:
                    messagebox.showerror("Error", f"Failed to delete {selected_item_text}: {e}")

    
    # This function is responsible for creating a new directory.
    #
    def create_dir(self):
        # Show a dialog asking for the name of the new directory
        new_dir_name = simpledialog.askstring("Create Directory", "Enter new directory name")

        # If the user didn't type a name, return
        if not new_dir_name:
            return

        # Try to create the directory
        new_dir_path = os.path.join(self.path, new_dir_name)
        try:
            os.mkdir(new_dir_path)
            self.update_file_list()
        except Exception as e:
            messagebox.showerror("Error", f"Failed to create directory '{new_dir_name}': {e}")


    # This function is a crucial part of the FileBrowser application, handling the task of refreshing the display of files 
    # and directories.
    #
            
    def update_file_list(self):
        if self.OS == 'Windows':
            self.update_file_list_Windows()
        elif self.OS == 'Linux':
            self.update_file_list_Linux()
        else:
            print("Unknown operating system.")


    def update_file_list_Windows(self):
        self.path = self.directory.get()
        self.file_list.delete(*self.file_list.get_children())
        if self.path != 'C:\\':
            self.file_list.insert("", "end", text='..', open=False, tags=('parent_directory',))
        try:
            dir_content = os.listdir(self.path)
        except FileNotFoundError:
            return

        dirs = []
        files = []
        for item in dir_content:
            item_full_path = os.path.join(self.path, item)
            if os.path.isdir(item_full_path):
                dirs.append(item)
            else:
                files.append(item)

        for dir in dirs:
            self.file_list.insert("", "end", text=dir, open=False, image=self.folder_icon)
        
        for file in files:
            file_path = os.path.join(self.path, file)
            file_info = os.stat(file_path)
            file_size = file_info.st_size
            file_modified_time = datetime.datetime.fromtimestamp(file_info.st_mtime).strftime('%Y-%m-%d %H:%M:%S')
            file_type = mimetypes.guess_type(file_path)[0] or "Unknown"
            
            self.file_list.insert("", "end", text=file, values=(file_size, file_modified_time, file_type), image=self.file_icon)

    def update_file_list_Linux(self):
        self.path = self.directory.get()
        self.file_list.delete(*self.file_list.get_children())
        if self.path != '/':
            self.file_list.insert("", "end", text='..', open=False, tags=('parent_directory',))
        try:
            dir_content = os.listdir(self.path)
        except FileNotFoundError:
            return

        dirs = []
        files = []
        for item in dir_content:
            item_full_path = os.path.join(self.path, item)
            if os.path.isdir(item_full_path):
                dirs.append(item)
            else:
                files.append(item)

        for dir in dirs:
            self.file_list.insert("", "end", text=dir, open=False, image=self.folder_icon)
        
        for file in files:
            file_path = os.path.join(self.path, file)
            file_info = os.stat(file_path)
            file_size = file_info.st_size
            file_modified_time = datetime.datetime.fromtimestamp(file_info.st_mtime).strftime('%Y-%m-%d %H:%M:%S')
            file_type = mimetypes.guess_type(file_path)[0] or "Unknown"
            
            self.file_list.insert("", "end", text=file, values=(file_size, file_modified_time, file_type), image=self.file_icon)

    # This function is responsible for changing the current directory based on user's selection in the file browser.
    #
    def navigate(self,event=None):   # Function to navigate to the selected directory 
        selected_item = self.file_list.selection()[0]
        selected_item_text = self.file_list.item(selected_item, "text")
        if selected_item_text == '..':
            new_path = os.path.dirname(self.path)
        else:
            new_path = os.path.join(self.path, selected_item_text)
        if os.path.exists(new_path):
            self.directory.set(new_path)
            self.update_file_list()


    # The function show_popup_menu(self, event) is invoked when you right-click on your Treeview widget. This function serves the purpose
    # of displaying a context menu at the current mouse cursor location.
    def show_popup_menu(self, event):
            # Show the context menu
            try:
                self.popup_menu.tk_popup(event.x_root, event.y_root)
            finally:
                # Make sure to release the grab (very important!) so that
                # the normal interactions with the application can continue
                self.popup_menu.grab_release()


    def open_with_simple_notepad(self):
        item = self.file_list.selection()[0]
        file_path = self.file_list.item(item, 'text')

        if file_path.endswith('.cfg') or file_path.endswith('.txt'):
            for selected_item in self.file_list.selection():
                selected_item_text = self.file_list.item(selected_item, "text")
                full_path = os.path.join(self.path, selected_item_text)
            notepad = SimpleNotepad(full_path)
            notepad.open()
        else:
            print("File Open not supported with this NotePad")            


# define Class for FileBrowser on remote PC
class FileBrowserSCP(tk.Frame):
    #def __init__(self, master=None, p='\' ):
    def __init__(self, master=None, initType = 'CALLBOX', initpath='/', initRemoteIP='192.168.100.17', initUserName='root', initPassword='toor'):

        super().__init__(master)
        self.Type = initType.upper()
        self.path = initpath
        self.remote_ip = initRemoteIP
        self.remote_username = initUserName
        self.remote_password = initPassword
        self.selectedFile = None  # Create the 'selectedFile' attribute
        # Create the rest of the widgets
        self.create_widgets()

    # This function is a method for managing the state of the connection between the local machine and the remote machine using the SFTP
    # protocol.  
    def toggle_connection(self):
        if self.connected:
            self.disconnect()
        else:
            self.connect()

    # This function is responsible for establishing a Secure Shell (SSH) connection to a remote machine, initializing an SFTP client for
    #  file transfer and operations, and updating the user interface to reflect the new connection state.
    #
    def connect(self):
        # Get entered remote machine details
        self.remote_ip = self.ip_entry.get()
        self.remote_username = self.username_entry.get()
        self.remote_password = self.password_entry.get()

        try:
            # Establish SSH connection
            self.ssh = paramiko.SSHClient()
            self.ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
            self.ssh.connect(self.remote_ip, username=self.remote_username, password=self.remote_password)

            # Initialize SFTP client
            self.sftp_client = self.ssh.open_sftp()
            print(f"SFTP client connected: {self.sftp_client}")  # Debugging line

            # Update the file list after a successful connection
            self.update_file_list()

            # Update the connection status and button text
            self.connected = True
            self.connect_button.config(text="Disconnect")

        except Exception as e:
            print(f"Failed to connect: {e}")
            messagebox.showerror("Connection Failed", f"Failed to connect: {e}")
            self.ssh = None
            self.sftp_client = None


    # This function is responsible for safely terminating the SSH and SFTP connections to the remote machine and updating the user interface
    # to reflect the disconnection.
    #
    def disconnect(self):
        if self.sftp_client:
            self.sftp_client.close()
            self.sftp_client = None

        if self.ssh:
            self.ssh.close()
            self.ssh = None

        # Update the connection status and button text
        self.connected = False
        self.connect_button.config(text="Connect")

        # Clear the file list
        self.file_list.delete(*self.file_list.get_children())


    # This function(method) sets up all the necessary graphical user interface (GUI) components, also known as 
    # "widgets", for the file browser application.
    #
    def create_widgets(self):

        self.grid(sticky='nsew')
        self.master.grid_rowconfigure(0, weight=1)
        self.master.grid_columnconfigure(0, weight=1)

        # Initialize SFTP client as None
        self.ssh = None
        self.sftp_client = None

        self.paths_to_copy = []

        # Load the icons
        self.folder_icon = tk.PhotoImage(file="icon_dir.png")
        self.file_icon = tk.PhotoImage(file="icon_file.png")
        self.link_icon = tk.PhotoImage(file="icon_link.png")

        # Create connection frame
        self.connection_frame = ttk.Frame(self)
        self.connection_frame.grid(row=0, column=0, sticky='ew')

        # IP address widget
        self.ip_label = ttk.Label(self.connection_frame, text="IP Address:")
        self.ip_label.grid(row=0, column=0, sticky='w')
        self.ip_entry = ttk.Entry(self.connection_frame)
        self.ip_entry.grid(row=0, column=1, sticky='ew')
        self.ip_entry.insert(0, self.remote_ip)

        # Username widget
        self.username_label = ttk.Label(self.connection_frame, text="Username:")
        self.username_label.grid(row=0, column=2, sticky='w')
        self.username_entry = ttk.Entry(self.connection_frame)
        self.username_entry.grid(row=0, column=3, sticky='ew')
        self.username_entry.insert(0, self.remote_username)

        # Password widget
        self.password_label = ttk.Label(self.connection_frame, text="Password:")
        self.password_label.grid(row=0, column=4, sticky='w')
        self.password_entry = ttk.Entry(self.connection_frame, show="*")
        self.password_entry.grid(row=0, column=5, sticky='ew')
        self.password_entry.insert(0, self.remote_password)

        self.connected = False

        # Connect/Disconnect button
        self.connect_button = ttk.Button(self.connection_frame, text="Connect", command=self.toggle_connection)
        self.connect_button.grid(row=0, column=6, sticky='ew')

        for col in range(7):
            self.connection_frame.grid_columnconfigure(col, weight=1)

        # Create a Menu
        self.popup_menu = tk.Menu(self, tearoff=0)
        self.popup_menu.add_command(label="Rename", command=self.rename_file)
        self.popup_menu.add_command(label="Copy", command=self.copy_file)
        self.popup_menu.add_command(label="Paste", command=self.paste_file)
        self.popup_menu.add_command(label="Delete", command=self.delete_file)
        self.popup_menu.add_command(label="Create Directory", command=self.create_dir)
        self.popup_menu.add_separator()
        self.popup_menu.add_command(label="Open File", command=self.open_with_simple_notepad)
        self.popup_menu.add_separator()
        if self.Type == 'CALLBOX' :
            self.popup_menu.add_command(label="Link enb", command=self.link_enb)
            self.popup_menu.add_command(label="Link mme", command=self.link_mme)
        if self.Type == 'UESIM' :
            self.popup_menu.add_command(label="Link ue", command=self.link_ue)
        self.popup_menu.add_separator()    
        self.popup_menu.add_command(label="Refresh", command=self.update_file_list)    

        self.navigation_frame = tk.Frame(self)  
        self.navigation_frame.grid(row=1, column=0, sticky='we')
        self.navigation_frame.grid_columnconfigure(0, weight=1)

        self.directory = tk.StringVar(value=self.path)
        self.entry = ttk.Entry(self.navigation_frame, textvariable=self.directory)
        self.button = ttk.Button(self.navigation_frame, text="Navigate", command=self.navigate_to_directory)
        self.entry.grid(row=0, column=0, padx=5, pady=5, sticky='ew')
        self.button.grid(row=0, column=1, padx=5, pady=5, sticky='ew')

        # Creating button frame
        self.button_frame = tk.Frame(self)
        #self.button_frame.pack(fill='x')
        self.button_frame.grid(row=2, column=0, sticky='nsew')

        self.rename_button = ttk.Button(self.button_frame, text="Rename", command=self.rename_file)
        self.copy_button = ttk.Button(self.button_frame, text="Copy", command=self.copy_file)
        self.paste_button = ttk.Button(self.button_frame, text="Paste", command=self.paste_file)
        self.delete_button = ttk.Button(self.button_frame, text="Delete", command=self.delete_file)
        self.create_dir_button = ttk.Button(self.button_frame, text="Create Dir", command=self.create_dir)
        if self.Type == 'CALLBOX' :
            self.linkenb_button = ttk.Button(self.button_frame, text="Link enb", command=self.link_enb)
            self.linkmme_button = ttk.Button(self.button_frame, text="Link mme", command=self.link_mme)
        if self.Type == 'UESIM' :
            self.linkue_button = ttk.Button(self.button_frame, text="Link ue", command=self.link_ue)
    

        self.rename_button.pack(side='left', padx=[5,0], pady=[0,5])
        self.copy_button.pack(side='left', pady=[0,5])
        self.paste_button.pack(side='left', pady=[0,5])
        self.delete_button.pack(side='left', pady=[0,5])
        self.create_dir_button.pack(side='left', pady=[0,5])
        if self.Type == 'CALLBOX' :
            self.linkenb_button.pack(side='left', padx=[10,0], pady=[0,5])
            self.linkmme_button.pack(side='left', pady=[0,5])
        if self.Type == 'UESIM' :
            self.linkue_button.pack(side='left', padx=[10,0], pady=[0,5])    

        # Creating Fileview frame
        self.file_frame = tk.Frame(self)
        self.file_frame.grid(row=3, column=0, sticky='nsew')
        self.file_frame.rowconfigure(0, weight=1)
        self.file_frame.columnconfigure(0, weight=1)
        self.rowconfigure(3, weight=1)
        self.columnconfigure(0, weight=1)   

        self.file_list = ttk.Treeview(self.file_frame, columns=('fullpath', 'type', 'size'), show='tree headings')
        self.file_list.column("#1", width=100)
        self.file_list.column("#2", width=150)
        self.file_list.column("#3", width=100)
        self.file_list.heading("#0", text="File Name")
        self.file_list.heading("#1", text="Size (bytes)")
        self.file_list.heading("#2", text="Modified Time")
        self.file_list.heading("#3", text="File Type")
        self.file_list.bind('<Double-1>', self.navigate)
        self.file_list.tag_configure('parent_directory', font=('TkDefaultFont', 14, 'bold'))
        self.file_list.bind("<Button-3>", self.show_popup_menu)

        self.file_list.bind('<Control-c>', self.copy_file)
        self.file_list.bind('<Control-v>', self.paste_file)

        self.file_list.bind('<<TreeviewSelect>>', self.select_file)

        self.file_list.grid(row=0, column=0, padx=5, pady=5, sticky='nsew')
        self.file_frame.columnconfigure(0, weight=1)
        self.file_frame.rowconfigure(0, weight=1)

        self.scrollbar = ttk.Scrollbar(self.file_frame, orient="vertical", command=self.file_list.yview)
        self.scrollbar.grid(row=0, column=1, sticky='ns')

        self.file_list.configure(yscrollcommand=self.scrollbar.set)

        # create the button frame at the bottom
        self.button_frame = tk.Frame(self)
        self.button_frame.grid(row=4, column=0, sticky='we')

        self.goto_log_button = ttk.Button(self.button_frame, text="goto Log", command=self.goto_log, width=15)
        self.goto_log_backup_button = ttk.Button(self.button_frame, text="goto Log Backup", command=self.goto_log_backup, width=15)
        if self.Type == 'CALLBOX' :
            self.goto_enb_config_button = ttk.Button(self.button_frame, text="goto enb config", command=self.goto_enb_config, width=15)
            self.goto_mme_config_button = ttk.Button(self.button_frame, text="goto mme config", command=self.goto_mme_config, width=15)
        if self.Type == 'UESIM' :
            self.goto_ue_config_button = ttk.Button(self.button_frame, text="goto ue config", command=self.goto_ue_config, width=15)

        self.goto_log_button.grid(row=0, column=0, padx=5, pady=5, sticky='ew')
        self.goto_log_backup_button.grid(row=0, column=1, padx=5, pady=5, sticky='ew')
        if self.Type == 'CALLBOX' :
            self.goto_enb_config_button.grid(row=0, column=2, padx=5, pady=5, sticky='ew')
            self.goto_mme_config_button.grid(row=0, column=3, padx=5, pady=5, sticky='ew')
        if self.Type == 'UESIM' :
            self.goto_ue_config_button.grid(row=0, column=2, padx=5, pady=5, sticky='ew')

        self.rowconfigure(0, weight=0)
        self.rowconfigure(1, weight=0)
        self.rowconfigure(2, weight=0)
        self.rowconfigure(3, weight=1)
        self.rowconfigure(4, weight=0)
        self.button_frame.columnconfigure(0, weight=1)
        self.button_frame.columnconfigure(1, weight=1)
        self.button_frame.columnconfigure(2, weight=1)
        self.button_frame.columnconfigure(3, weight=1)
        self.button_frame.columnconfigure(4, weight=1)


    # assign the selected file path and name to the public variable selectedFile
    def select_file(self, event):
        selected = self.file_list.selection()  # Get the selected items
        if selected:
            item = self.file_list.item(selected[0])  # Get the first selected item
            self.selectedFile = f"{self.path}/{item['text']}"  # Update the 'selectedFile' attribute
        print('Selected File = ',self.remote_ip , ':' , self.selectedFile)    
        print('Selected Path = ',self.remote_ip , ':' , self.path) 


    def rename_file(self):
        # Get selected file or directory
        selected_item = self.file_list.selection()[0]
        selected_item_text = self.file_list.item(selected_item, "text")

        def rename(event=None):
            new_name = new_name_var.get()
            old_path = f"{self.path}/{selected_item_text}"
            new_path = f"{self.path}/{new_name}"
            print(f"Old path: {old_path}")
            print(f"New path: {new_path}")

            try:
                self.sftp_client.rename(old_path, new_path)
                self.update_file_list()
            except Exception as e:
                print(f"Error renaming file: {e}")

            # Destroy the Entry widget when done
            new_name_entry.destroy()

        # Function to handle the ESC key
        def handle_esc(event=None):
            new_name_entry.destroy()

        # Get the position of the selected item in the treeview
        x, y, _, _ = self.file_list.bbox(selected_item)

        # Create an Entry widget at the position of the selected item
        new_name_var = tk.StringVar()
        new_name_entry = ttk.Entry(self.file_list, textvariable=new_name_var, width=len(selected_item_text))
        new_name_entry.place(x=x, y=y)
        new_name_var.set(selected_item_text)
        new_name_entry.focus()

        # Bind the Enter key to the rename function
        new_name_entry.bind('<Return>', rename)

        # Bind the ESC key to the handle_esc function
        new_name_entry.bind('<Escape>', handle_esc)
    


    # This function is designed to rename a selected file or directory in the FileBrowser application.
    #
    def link_enb(self):
        # Get selected file or directory
        selected_item = self.file_list.selection()[0]
        selected_item_text = self.file_list.item(selected_item, "text")

        old_path = f"{self.path}/{selected_item_text}"
        new_path = "/root/enb/config/enb.cfg"
        #link_target = os.path.relpath(old_path, "/root/enb/config").strip("'")
        #link_target = os.path.relpath(old_path, "/root/ue/config").replace("\\", "/")
        if old_path == "/root/enb/config":
            link_target = selected_item_text
        else:
            link_target = os.path.relpath(old_path, "/root/enb/config").replace("\\", "/")

        print(f"Old path: {old_path}")
        print(f"New path: {new_path}")
        print(f"Link target: {link_target}")

        try:
            # Remove existing symbolic link if it exists
            if self.sftp_client.lstat(new_path).st_mode & stat.S_IFLNK:
                self.sftp_client.unlink(new_path)

            # Create a new symbolic link
            self.sftp_client.symlink(link_target, new_path)
            self.update_file_list()
            self.goto_enb_config()
        except Exception as e:
            print(f"Error creating symbolic link: {e}")
  


    # This function is designed to rename a selected file or directory in the FileBrowser application.
    #
    def link_mme(self):
        # Get selected file or directory
        selected_item = self.file_list.selection()[0]
        selected_item_text = self.file_list.item(selected_item, "text")

        #old_path = f"{self.path}/{selected_item_text}"
        #new_path = f"{self.path}/mme.cfg"
        #link_target = selected_item_text

        old_path = f"{self.path}/{selected_item_text}"
        new_path = "/root/mme/config/mme.cfg"
        if old_path == "/root/mme/config":
            link_target = selected_item_text
        else:
            link_target = os.path.relpath(old_path, "/root/mme/config").replace("\\", "/")

        print(f"Old path: {old_path}")
        print(f"New path: {new_path}")

        try:
            # Remove existing symbolic link if it exists
            if self.sftp_client.lstat(new_path).st_mode & stat.S_IFLNK:
                self.sftp_client.unlink(new_path)

            # Create a new symbolic link
            self.sftp_client.symlink(link_target, new_path)
            self.update_file_list()
            self.goto_mme_config()
        except Exception as e:
            print(f"Error creating symbolic link: {e}")


    # This function is designed to rename a selected file or directory in the FileBrowser application.
    #
    def link_ue(self):
        # Get selected file or directory
        selected_item = self.file_list.selection()[0]
        selected_item_text = self.file_list.item(selected_item, "text")

        old_path = f"{self.path}/{selected_item_text}"
        new_path = "/root/ue/config/ue.cfg"
        #link_target = os.path.relpath(old_path, "/root/ue/config").strip("'")
        #link_target = os.path.relpath(old_path, "/root/ue/config").replace("\\", "/")
        if old_path == "/root/ue/config":
            link_target = selected_item_text
        else:
            link_target = os.path.relpath(old_path, "/root/ue/config").replace("\\", "/")

        print(f"Old path: {old_path}")
        print(f"New path: {new_path}")
        print(f"Link target: {link_target}")

        try:
            # Remove existing symbolic link if it exists
            if self.sftp_client.lstat(new_path).st_mode & stat.S_IFLNK:
                self.sftp_client.unlink(new_path)

            # Create a new symbolic link
            self.sftp_client.symlink(link_target, new_path)
            self.update_file_list()
            self.goto_ue_config()
        except Exception as e:
            print(f"Error creating symbolic link: {e}")



    # this function is to let you go to /tmp directory
    def goto_log(self):
        self.entry.delete(0, 'end')  # Clear the current entry
        self.entry.insert(0, '/tmp')  # Put '/tmp' into the entry
        self.navigate_to_directory()  # Execute navigate_to_directory

    # this function is to let you go to /var/log directory
    def goto_log_backup(self):
        self.entry.delete(0, 'end')  # Clear the current entry
        self.entry.insert(0, '/var/log')  # Put '/tmp' into the entry
        self.navigate_to_directory()  # Execute navigate_to_directory


    # this function is to let you go to /root/enb/config directory
    def goto_enb_config(self):
        self.entry.delete(0, 'end')  # Clear the current entry
        self.entry.insert(0, '/root/enb/config')  # Put '/tmp' into the entry
        self.navigate_to_directory()  # Execute navigate_to_directory    

    # this function is to let you go to /root/mme/config directory 
    def goto_mme_config(self):
        self.entry.delete(0, 'end')  # Clear the current entry
        self.entry.insert(0, '/root/mme/config')  # Put '/tmp' into the entry
        self.navigate_to_directory()  # Execute navigate_to_directory       

    # this function is to let you go to /root/enb/config directory
    def goto_ue_config(self):
        self.entry.delete(0, 'end')  # Clear the current entry
        self.entry.insert(0, '/root/ue/config')  # Put '/tmp' into the entry
        self.navigate_to_directory()  # Execute navigate_to_directory    

    # This function is designed to copy one or more selected files within the FileBrowser application.
    # 
    def copy_file(self, event=None):
        # Get selected files
        for selected_item in self.file_list.selection():
            selected_item_text = self.file_list.item(selected_item, "text")
            full_path = self.path + '/' + selected_item_text
            self.paths_to_copy.append(full_path)


    # This function is designed to paste the files that have been previously selected for copying in the FileBrowser
    # application.
    #
    def paste_file(self, event=None):
        # If there are files to copy
        if self.paths_to_copy:
            try:
                for path_to_copy in self.paths_to_copy:
                    print(f"Trying to copy file: {path_to_copy}")

                    # Check if the file exists
                    try:
                        self.sftp_client.stat(path_to_copy)
                    except IOError:
                        print(f"File {path_to_copy} does not exist, skipping...")
                        continue

                    # Get the base name of the file to copy
                    file_name = os.path.basename(path_to_copy)
                    # Compute the full path of the new file
                    new_file_path = self.path + '/' + file_name

                    print(f"File to paste to: {new_file_path}")

                    # If a file with the same name already exists in the destination directory
                    try:
                        # Try to stat the file. If it doesn't exist, an IOError will be raised.
                        self.sftp_client.stat(new_file_path)
                        # If the previous line didn't raise an exception, the file exists.
                        # Split the file name into name and extension
                        name, ext = os.path.splitext(file_name)
                        # Append '-Copy' to the name and reassemble the file name
                        new_file_name = f"{name}-Copy{ext}"
                        # Compute the full path of the new file
                        new_file_path = self.path + '/' + new_file_name
                    except IOError:
                        # If an IOError was raised, the file doesn't exist and we can safely write to new_file_path
                        pass


                    print(f"Trying to paste to: {new_file_path}")

                    # Create a temporary file on the local system
                    with tempfile.NamedTemporaryFile(delete=False) as temp_file:
                        temp_path = temp_file.name
                    print("temp_path=", temp_path)
                    # Download the file to the temporary file
                    self.sftp_client.get(path_to_copy, temp_path)
                    # Upload the file from the temporary file to the new location
                    self.sftp_client.put(temp_path, new_file_path)
                    # Delete the temporary file
                    #os.remove(temp_path)

                # Clear the list of files to copy
                self.paths_to_copy = []
                self.update_file_list()
            except Exception as e:
                messagebox.showerror("Error", f"Failed to paste files: {e}")
        else:
            messagebox.showerror("Error", "No files to paste.")




    # This function is responsible for deleting selected files and directories in the FileBrowser application.
    #
    def delete_file(self):
        # Get selected items
        selected_items = self.file_list.selection()

        if not selected_items:
            messagebox.showerror("Error", "No file or directory selected.")
            return

        response = messagebox.askokcancel("Confirm delete", "Are you sure you want to delete the selected items?")

        if response:
            for selected_item in selected_items:
                selected_item_text = self.file_list.item(selected_item, "text")
                full_path = self.path + '/' + selected_item_text

                try:
                    attrs = self.sftp_client.stat(full_path)
                    
                    # If the selected item is a file, delete it
                    if stat.S_ISREG(attrs.st_mode):
                        self.sftp_client.remove(full_path)
                    # If the selected item is a directory, delete it and all its contents
                    elif stat.S_ISDIR(attrs.st_mode):
                        file_list = self.sftp_client.listdir(full_path)
                        # Check if directory is not empty
                        if file_list:
                            response = messagebox.askokcancel("Directory not empty", 
                                                            "This directory is not empty. All the files within the directory will be deleted as well. Do you want to delete?")
                            if response:
                                for file in file_list:
                                    self.sftp_client.remove(full_path + '/' + file)
                                self.sftp_client.rmdir(full_path)
                            else:
                                continue
                        else:
                            self.sftp_client.rmdir(full_path)
                    self.update_file_list()
                except Exception as e:
                    messagebox.showerror("Error", f"Failed to delete {selected_item_text}: {e}")


    
    # This function is responsible for creating a new directory.
    #
    def create_dir(self):
        # Show a dialog asking for the name of the new directory
        new_dir_name = simpledialog.askstring("Create Directory", "Enter new directory name")

        # If the user didn't type a name, return
        if not new_dir_name:
            return

        # Try to create the directory
        new_dir_path = self.path + '/' + new_dir_name
        try:
            self.sftp_client.mkdir(new_dir_path)  # Use the mkdir method of sftp_client
            self.update_file_list()
        except Exception as e:
            messagebox.showerror("Error", f"Failed to create directory '{new_dir_name}': {e}")


    # This function is a crucial part of the FileBrowser application, handling the task of refreshing the display of files 
    # and directories.
    #
    def update_file_list(self):
        # Clear the current items in the tree view
        for i in self.file_list.get_children():
            self.file_list.delete(i)

        try:
            # Execute the 'ls -l' command over SSH
            stdin, stdout, stderr = self.ssh.exec_command(f'ls -l {self.path}')
            file_lines = stdout.readlines()

            directories = []
            files = []

            # Manually add the parent directory to the list
            if self.path != "/":
                directories.append(('..', 'dir', '', '', self.folder_icon))

            for line in file_lines[1:]:  # Exclude the first line, which is a total count
                # Use regular expression to parse the line
                match = re.match(r'^([\-dlt])([\w-]+)\.?(\s+\d+)\s+(\w+)\s+(\w+)\s+(\d+)\s+(\w+)\s+(\d+)\s+(\d+:\d+|\d+)\s+(.+)$', line.strip())
                
                if match is not None:
                    file_type = 'file' if match.group(1) == '-' else 'dir' if match.group(1) == 'd' else 'link'
                    image = self.file_icon if file_type == 'file' else self.folder_icon if file_type == 'dir' else self.link_icon
                    file_size = match.group(6)
                    date_string = f"{match.group(7)} {match.group(8)} {match.group(9)}"
                    #modified_time = datetime.strptime(date_string, '%b %d %H:%M' if ':' in date_string else '%b %d %Y')
                    modified_time = datetime.datetime.strptime(date_string, '%b %d %H:%M' if ':' in date_string else '%b %d %Y')
                    file_name = match.group(10)

                    # Add the item to the correct list
                    if file_type == 'dir':
                        directories.append((file_name, file_type, file_size, modified_time, image))
                    else:
                        files.append((file_name, file_type, file_size, modified_time, image))
                else:
                    print(f"Unexpected file_info format: {line}")

            # Insert the directories and files into the tree view
            for name, type, size, time, image in directories + files:
                self.file_list.insert('', 'end', text=name, values=(type, size, time), image=image)

        except Exception as e:
            print(f"Error updating file list: {e}")


    # This function is responsible for changing the current directory based on user's selection in the file browser.
    #
    def navigate(self, event=None):

        if self.sftp_client is None:
            print("SFTP client is not connected")
            return
        # Function to navigate to the selected directory
        selected_item = self.file_list.selection()
        if not selected_item:  # No selection made
            return

        selected_item_text = self.file_list.item(selected_item, "text")

        if '->' in selected_item_text:  # If this is a symbolic link
            selected_item_text = selected_item_text.split('->')[1].strip()  # Use the target of the symbolic link
            new_path = selected_item_text
        elif selected_item_text == '..':
            if self.path.split('/').__len__() <= 2 :
                new_path = '/'
            else :    
                new_path = '/'.join(self.path.split('/')[:-1])  # Use POSIX-style path separator
        else:
            new_path = '/'.join([self.path, selected_item_text])  # Use POSIX-style path separator

        new_path = new_path.replace("//","/")
        self.directory.set(new_path)
        print(f"Selected item: {selected_item_text}")
        print(f"New path: {new_path}")

        try:
            attrs = self.sftp_client.stat(new_path)
            if stat.S_ISLNK(attrs.st_mode):
                # If it's a symbolic link, get the target directory
                new_path = self.sftp_client.readlink(new_path)

            # Check if the target directory exists and is a directory
            attrs = self.sftp_client.stat(new_path)
            if stat.S_ISDIR(attrs.st_mode):
                self.path = new_path
                print("Navigating to directory...")
                self.update_file_list()
            else:
                print("Not a directory, skipping navigation.")

        except IOError as e:
            print(f"Error during navigation: {e}")



    # This function, navigate_to_directory(), is used to navigate to a directory specified in the text box. Here's a step-by-step
    # description of what the code does:
    #
    def navigate_to_directory(self):
        new_path = self.directory.get()  # Get the directory from the text box
        print(f"Navigate button pressed. Trying to navigate to: {new_path}")

        try:
            # stat() will follow the symbolic link and raise an IOError if the target does not exist
            attrs = self.sftp_client.stat(new_path)
            if stat.S_ISLNK(attrs.st_mode):
                # If it's a symbolic link, get the target directory
                new_path = self.sftp_client.readlink(new_path)

            # Check if the target directory exists
            self.sftp_client.stat(new_path)
            self.path = new_path
            print(f"Changing directory to: {self.path}")
            self.update_file_list()

        except IOError:
            print(f"Error during navigation: Directory {new_path} does not exist.")


    # The function show_popup_menu(self, event) is invoked when you right-click on your Treeview widget. This function serves the purpose
    # of displaying a context menu at the current mouse cursor location.
    def show_popup_menu(self, event):
            # Show the context menu
            try:
                self.popup_menu.tk_popup(event.x_root, event.y_root)
            finally:
                # Make sure to release the grab (very important!) so that
                # the normal interactions with the application can continue
                self.popup_menu.grab_release()

    def open_with_simple_notepad(self):
        item = self.file_list.selection()[0]
        file_path = self.file_list.item(item, 'text')
        self.remote_ip = self.ip_entry.get()
        self.remote_username = self.username_entry.get()
        self.remote_password = self.password_entry.get()

        if file_path.endswith('.cfg') or file_path.endswith('.txt'):
            for selected_item in self.file_list.selection():
                selected_item_text = self.file_list.item(selected_item, "text")
                #full_path = os.path.join(self.path, selected_item_text)
                full_path = self.path + '/' + selected_item_text
            print(f"Trying to open file: {full_path}")    
            notepad = SimpleNotepad(full_path)
            notepad.remote_ip = self.remote_ip
            notepad.remote_username = self.remote_username
            notepad.remote_password = self.remote_password
            notepad.system="REMOTE"
            notepad.open_remote()
        else:
            print("File Open not supported with this NotePad") 

# define Class for FileBrowser on remote PC
class ScreenSSH(tk.Frame):
    #def __init__(self, master=None, p='\' ):
    def __init__(self, master=None, initType = 'CALLBOX', initpath='/', initRemoteIP='192.168.100.17', initUserName='root', initPassword='toor'):

        super().__init__(master)
        self.Type = initType.upper()
        self.path = initpath
        self.remote_ip = initRemoteIP
        self.remote_username = initUserName
        self.remote_password = initPassword
        self.selectedFile = None  # Create the 'selectedFile' attribute
        self.thread = None
        self.stop_thread = False
        self.isInScreen = False
        self.mme_index = 0
        self.enb_index = 1
        self.ims_index = 3
        # Create the rest of the widgets
        self.create_widgets()

    # This function is a method for managing the state of the connection between the local machine and the remote machine using the SFTP
    # protocol.  
    def toggle_connection(self):
        if self.connected:
            self.disconnect()
        else:
            self.connect()

    # This function is responsible for establishing a Secure Shell (SSH) connection to a remote machine, initializing an SFTP client for
    #  file transfer and operations, and updating the user interface to reflect the new connection state.
    #
    def connect(self):
        # Get entered remote machine details
        self.stop_thread = False
        self.remote_ip = self.ip_entry.get()
        self.remote_username = self.username_entry.get()
        self.remote_password = self.password_entry.get()

        try:
            # Establish SSH connection
            self.ssh = paramiko.SSHClient()
            self.ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
            self.ssh.connect(self.remote_ip, username=self.remote_username, password=self.remote_password)
            print(f"SSH client connected: {self.ssh}")  # Debugging line

            # Update the connection status and button text
            self.connected = True
            self.connect_button.config(text="Disconnect")

            self.channel = self.ssh.invoke_shell(term='xterm', width=120)
            self.thread = threading.Thread(target=self.read_from_channel, args=(self.channel, self.terminal), daemon=True).start()

        except Exception as e:
            print(f"Failed to connect: {e}")
            messagebox.showerror("Connection Failed", f"Failed to connect: {e}")
            self.ssh = None
            self.isInScreen = False


    # This function is responsible for safely terminating the SSH and SFTP connections to the remote machine and updating the user interface
    # to reflect the disconnection.
    #
    def disconnect(self):
        
        self.stop_thread = True
        if self.ssh:
            self.ssh.close()
            self.ssh = None

        # Update the connection status and button text
        self.connected = False
        self.connect_button.config(text="Connect")
        print(f"SSH client Disconnected: {self.ssh}")  # Debugging line


                
    # This function(method) sets up all the necessary graphical user interface (GUI) components, also known as 
    # "widgets", for the file browser application.
    #
    def create_widgets(self):

        self.grid(sticky='nsew')
        self.master.grid_rowconfigure(0, weight=1)
        self.master.grid_columnconfigure(0, weight=1)

        # Initialize SFTP client as None
        self.ssh = None
        self.sftp_client = None

        self.paths_to_copy = []

        # Load the icons
        self.folder_icon = tk.PhotoImage(file="icon_dir.png")
        self.file_icon = tk.PhotoImage(file="icon_file.png")
        self.link_icon = tk.PhotoImage(file="icon_link.png")

        # Create connection frame
        self.connection_frame = ttk.Frame(self)
        self.connection_frame.grid(row=0, column=0, sticky='ew')

        # IP address widget
        self.ip_label = ttk.Label(self.connection_frame, text="IP Address:")
        self.ip_label.grid(row=0, column=0, sticky='w')
        self.ip_entry = ttk.Entry(self.connection_frame)
        self.ip_entry.grid(row=0, column=1, sticky='ew')
        self.ip_entry.insert(0, self.remote_ip)

        # Username widget
        self.username_label = ttk.Label(self.connection_frame, text="Username:")
        self.username_label.grid(row=0, column=2, sticky='w')
        self.username_entry = ttk.Entry(self.connection_frame)
        self.username_entry.grid(row=0, column=3, sticky='ew')
        self.username_entry.insert(0, self.remote_username)

        # Password widget
        self.password_label = ttk.Label(self.connection_frame, text="Password:")
        self.password_label.grid(row=0, column=4, sticky='w')
        self.password_entry = ttk.Entry(self.connection_frame, show="*")
        self.password_entry.grid(row=0, column=5, sticky='ew')
        self.password_entry.insert(0, self.remote_password)

        self.connected = False

        # Connect/Disconnect button
        self.connect_button = ttk.Button(self.connection_frame, text="Connect", command=self.toggle_connection)
        self.connect_button.grid(row=0, column=6, sticky='ew')

        # Launch Screen
        self.RunScreen_button = ttk.Button(self.connection_frame, text="Run Screen", command=self.process_RunScreen)
        self.RunScreen_button.grid(row=0, column=7, sticky='ew')

        # Quit Screen
        self.RunScreen_button = ttk.Button(self.connection_frame, text="Quit Screen", command=self.process_QuitScreen)
        self.RunScreen_button.grid(row=0, column=8, sticky='ew')

        # Clear Screen
        self.ClearScreen_button = ttk.Button(self.connection_frame, text="Clear Screen", command=self.process_ClearScreen)
        self.ClearScreen_button.grid(row=0, column=9, sticky='ew')

        for col in range(10):
            self.connection_frame.grid_columnconfigure(col, weight=1)

        # Creating button frame for eNB screen command
        self.button_frame = tk.Frame(self, bd=2, relief="groove")
        self.button_frame.grid(row=2, column=0, sticky='nsew')

        self.enb_label = tk.Label(self.button_frame, text="ENB Command:")
        self.enb_cell_phy_button = ttk.Button(self.button_frame, text="cell phy", command=self.process_Cmd_cell_phy)
        self.enb_cell_button = ttk.Button(self.button_frame, text="cell", command=self.process_Cmd_cell)
        self.enb_t_button = ttk.Button(self.button_frame, text="t", command=self.process_Cmd_t)
        self.enb_t_spl_button = ttk.Button(self.button_frame, text="t spl", command=self.process_Cmd_t_spl)
        self.enb_t_spl_dbm_button = ttk.Button(self.button_frame, text="t spl dbm", command=self.process_Cmd_t_spl_dbm)
        self.enb_t_cpu_button = ttk.Button(self.button_frame, text="t cpu", command=self.process_Cmd_t_cpu)
        self.enb_t_g_button = ttk.Button(self.button_frame, text="t g", command=self.process_Cmd_t_g)
        self.enb_ue_button = ttk.Button(self.button_frame, text="ue", command=self.process_Cmd_enb_ue)
        self.enb_rf_info_button = ttk.Button(self.button_frame, text="rf_info", command=self.process_Cmd_rf_info)
    
        self.enb_label.pack(side='left', padx=[5,0], pady=[5,5])
        self.enb_cell_phy_button.pack(side='left', padx=[5,0], pady=[5,5])
        self.enb_cell_button.pack(side='left', padx=[5,0], pady=[5,5])
        self.enb_t_button.pack(side='left', padx=[5,0], pady=[5,5])
        self.enb_t_spl_button.pack(side='left', pady=[5,5])
        self.enb_t_spl_dbm_button.pack(side='left', pady=[5,5])
        self.enb_t_cpu_button.pack(side='left', pady=[5,5])
        self.enb_t_g_button.pack(side='left', pady=[5,5])
        self.enb_ue_button.pack(side='left', pady=[5,5])
        self.enb_rf_info_button.pack(side='left', pady=[5,5])

        # Creating button frame for mme screen command
        self.button_frame = tk.Frame(self, bd=2, relief="groove")
        self.button_frame.grid(row=3, column=0, sticky='nsew')

        self.mme_label = tk.Label(self.button_frame, text="MME Command:")
        self.mme_ue_button = ttk.Button(self.button_frame, text="ue", command=self.process_mme_ue)
        self.mme_ng_ran_button = ttk.Button(self.button_frame, text="ng ran", command=self.process_mme_ng_ran)

        self.mme_label.pack(side='left', padx=[5,0], pady=[5,5])
        self.mme_ue_button.pack(side='left', padx=[5,0], pady=[5,5])
        self.mme_ng_ran_button.pack(side='left', padx=[5,0], pady=[5,5])
      

        # Creating button frame for ims screen command
        self.button_frame = tk.Frame(self, bd=2, relief="groove")
        self.button_frame.grid(row=4, column=0, sticky='nsew')

        self.ims_label = tk.Label(self.button_frame, text="IMS Command:")
        self.ims_t_button = ttk.Button(self.button_frame, text="t", command=self.process_ims_t)
        self.ims_users_button = ttk.Button(self.button_frame, text="users", command=self.process_ims_users)
        self.ims_ipsec_button = ttk.Button(self.button_frame, text="ipsec", command=self.process_ims_ipsec)
        self.ims_mt_call_button = ttk.Button(self.button_frame, text="mt_call", command=self.process_ims_mt_call)
    
        self.ims_label.pack(side='left', padx=[5,0], pady=[5,5])
        self.ims_t_button.pack(side='left', padx=[5,0], pady=[5,5])
        self.ims_users_button.pack(side='left', padx=[5,0], pady=[5,5])
        self.ims_ipsec_button.pack(side='left', padx=[5,0], pady=[5,5])
        self.ims_mt_call_button.pack(side='left', pady=[5,5])

        # Creating terminal frame
        self.terminal_frame = tk.Frame(self)
        self.terminal_frame.grid(row=5, column=0, sticky='nsew')
        self.terminal_frame.rowconfigure(0, weight=1)
        self.terminal_frame.columnconfigure(0, weight=1)
        self.rowconfigure(3, weight=1)
        self.columnconfigure(0, weight=1)   

        self.terminal = scrolledtext.ScrolledText(self.terminal_frame, 
                                          font=("Lucida Console", 10), 
                                          bg="black", 
                                          fg="white")
        self.terminal.grid(row=0, column=0, padx=5, pady=5, sticky='nsew')
        self.terminal.columnconfigure(0, weight=1)
        self.terminal.rowconfigure(0, weight=1)

        # create the button frame at the bottom
        self.button_frame = tk.Frame(self)
        self.button_frame.grid(row=6, column=0, sticky='we')

        self.screen_label = tk.Label(self.button_frame, text="Command:")
        self.screen_label.grid(row=0, column=0, padx=[5,0], pady=[5,5],sticky='w') 

        self.entry = tk.Entry(self.button_frame)
        self.entry.grid(row=0, column=1, columnspan=3,padx=[5,0], pady=[5,5], sticky='we')  # sticky='we' makes the Entry expand horizontally
        self.entry.bind('<Return>', self.on_enter_key)
        self.entry.bind('<Control-a>', self.send_ctrl_a)

        self.run_button = ttk.Button(self.button_frame, text="ENTER", command=self.process_Run)
        self.run_button.grid(row=0, column=4, padx=[5,0], pady=[5,5],sticky='w') 

        self.goto_enb_button = ttk.Button(self.button_frame, text="goto (enb)", command=self.process_goto_enb, width=15)
        self.goto_mme_button = ttk.Button(self.button_frame, text="goto (mme)", command=self.process_goto_mme, width=15)
        self.goto_ims_button = ttk.Button(self.button_frame, text="goto (ims)", command=self.process_goto_ims, width=15)

        self.goto_enb_button.grid(row=0, column=5, padx=[5,0], pady=[5,5],sticky='w') 
        self.goto_mme_button.grid(row=0, column=6, padx=[5,0], pady=[5,5],sticky='w') 
        self.goto_ims_button.grid(row=0, column=7, padx=[5,0], pady=[5,5],sticky='w') 

        # Make the Entry widget expand to fill the available space
        self.button_frame.grid_columnconfigure(1, weight=1)

        self.rowconfigure(0, weight=0)
        self.rowconfigure(1, weight=0)
        self.rowconfigure(2, weight=0)
        self.rowconfigure(3, weight=0)
        self.rowconfigure(4, weight=0)
        self.rowconfigure(5, weight=1)
        self.rowconfigure(6, weight=0)
        self.rowconfigure(7, weight=0)
        self.button_frame.columnconfigure(0, weight=1)
        self.button_frame.columnconfigure(1, weight=1)
        self.button_frame.columnconfigure(2, weight=1)
        self.button_frame.columnconfigure(3, weight=1)
        self.button_frame.columnconfigure(4, weight=1)
        self.button_frame.columnconfigure(5, weight=1)
        self.button_frame.columnconfigure(6, weight=1)
        self.button_frame.columnconfigure(7, weight=1)

    def write_to_channel(self, channel, command):
        channel.send(command + "\n")

    def on_enter_key(self,event):
        command = self.entry.get()
        self.entry.delete(0, tk.END)
        self.write_to_channel(self.channel, command)

    def send_ctrl_a(self, event):
        self.channel.send(chr(1))  


    def read_from_channel(self, channel, terminal):
        output_buffer = ""
        #while True:
        while not self.stop_thread:
            if channel.recv_ready():
                output = channel.recv(2048).decode()

                output_buffer += output
                
                # remove specific format
                format_to_remove = re.compile(r'CBC-\S+:root')
                output_buffer = format_to_remove.sub('', output_buffer)

                #format_to_remove = re.compile(r'\d+\s*MME')
                #output_buffer = format_to_remove.sub('', output_buffer)
                format_to_find = re.compile(r'(\d+)\s*MME')
                digits = format_to_find.findall(output_buffer)
                output_buffer = format_to_find.sub('', output_buffer)
                if digits:
                    first_digit = int(digits[0])
                    self.mme_index = first_digit

                #format_to_remove = re.compile(r'\d+\s*ENB')
                #output_buffer = format_to_remove.sub('', output_buffer)
                format_to_find = re.compile(r'(\d+)\s*ENB')
                digits = format_to_find.findall(output_buffer)
                output_buffer = format_to_find.sub('', output_buffer)
                if digits:
                    first_digit = int(digits[0])
                    self.enb_index = first_digit

                #format_to_remove = re.compile(r'\d+\s*IMS')
                #output_buffer = format_to_remove.sub('', output_buffer)
                format_to_find = re.compile(r'(\d+)\s*IMS')
                digits = format_to_find.findall(output_buffer)
                output_buffer = format_to_find.sub('', output_buffer)
                if digits:
                    first_digit = int(digits[0])
                    self.ims_index = first_digit

                format_to_remove = re.compile(r'\d+\s*MBMSGW')
                output_buffer = format_to_remove.sub('', output_buffer)

                format_to_remove = re.compile(r'\d+\s*(MBMSGW)')
                output_buffer = format_to_remove.sub('', output_buffer)

                format_to_remove = re.compile(r'\d+\s*\(MBMSGW\)')
                output_buffer = format_to_remove.sub('', output_buffer)

                output_buffer = re.sub(r'\s*\d{2}/\d{2}/\d{2}\s*', '', output_buffer)
                output_buffer = re.sub(r'\s*\d{2}:\d{2}\s*', '', output_buffer)

                # remove ANSI escape sequences
                ansi_escape = re.compile(r'\x1B(?:[@-Z\\-_]|\[[0-?]*[ -/]*[@-~])')
                output_buffer = ansi_escape.sub('', output_buffer)

                format_to_remove = re.compile(r'\[')
                output_buffer = format_to_remove.sub('', output_buffer)
                format_to_remove = re.compile(r'\]')
                output_buffer = format_to_remove.sub('', output_buffer)

                format_to_remove = re.compile(r'\b\d+:\d{2}\b')
                output_buffer = format_to_remove.sub('', output_buffer)

                printable_output = ''.join(char if char.isprintable() or char in '\n\r\t' else ' ' for char in output_buffer)
                terminal.insert(tk.END, printable_output)
                terminal.see(tk.END)

                # clear the buffer
                output_buffer = ""


    # This function is designed to Launch
    def process_RunScreen(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.entry.insert(0, 'screen -r')  # Insert 'screen -r' at the beginning
        self.process_Run()
        self.isInScreen = True


    # This function is designed to Quit
    def process_QuitScreen(self):
        self.channel.send(chr(1)) 
        self.channel.send('d') 
        self.isInScreen = False

    # This function is designed to process Screen Command 
    def process_Run(self):
        command = self.entry.get()
        self.entry.delete(0, tk.END)
        #self.write_to_channel(self.channel, 'stty -echo')  # Turn off echo
        self.write_to_channel(self.channel, command)  # Send the command
        #self.write_to_channel(self.channel, 'stty echo')  # Turn echo back on

    # This function is designed to process Screen Command 
    def process_ClearScreen(self):
        self.terminal.delete('1.0', 'end')
        self.process_Run()  


    # This function is designed to process Screen Command 
    def process_Cmd_cell_phy(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 'cell phy')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_Cmd_cell(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 'cell')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_Cmd_t(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 't')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_Cmd_t_spl(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 't spl')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_Cmd_t_spl_dbm(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 't spl dbm')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_Cmd_t_cpu(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 't cpu')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_Cmd_t_g(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 't g')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_Cmd_rf_info(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 'rf_info')  # Insert 'screen -r' at the beginning
        self.process_Run()    

    # This function is designed to process Screen Command 
    def process_Cmd_enb_ue(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 'ue')  # Insert 'screen -r' at the beginning
        self.process_Run()    

    # This function is designed to process Screen Command 
    def process_goto_enb(self):
        self.process_Run()
        self.process_Run()
        self.channel.send(chr(1)) 
        self.channel.send(str(self.enb_index))

    # This function is designed to process Screen Command 
    def process_goto_mme(self):
        self.process_Run()
        self.process_Run()
        self.channel.send(chr(1)) 
        self.channel.send(str(self.mme_index))

    # This function is designed to process Screen Command 
    def process_goto_ims(self):
        self.process_Run()
        self.process_Run()
        self.channel.send(chr(1)) 
        self.channel.send(str(self.ims_index))

    # This function is designed to process Screen Command 
    def process_mme_ue(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 'ue')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_mme_ng_ran(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 'ng_ran')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_ims_t(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 't')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_ims_users(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 'users')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_ims_ipsec(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 'ipsec')  # Insert 'screen -r' at the beginning
        self.process_Run()

    # This function is designed to process Screen Command 
    def process_ims_mt_call(self):
        self.entry.delete(0, tk.END)  # Clear the entry
        self.process_Run()
        self.entry.insert(0, 'mt_call')  # Insert 'screen -r' at the beginning
        self.process_Run()


# Event Handler for 'Service Stop' button on tab1
# ssh to the target ip (txtIP) and execute the command 'service lte stop'
def lteServiceStop(txtIP):

    root.config(cursor="watch")
    root.update()  # force update of screen

    ip_address = txtIP.get()
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    ssh.connect(ip_address, username='root', password='toor')
    stdin, stdout, stderr = ssh.exec_command('service lte stop')
    time.sleep(2) 
    ssh.close()

    root.config(cursor="")
    root.update()  # force update of screen


# Event Handler for 'Service Restart' button on tab1
# ssh to the target ip (txtIP) and execute the command 'service lte restart'
def lteServiceRestart(txtIP):

    root.config(cursor="watch")
    root.update()  # force update of screen

    ip_address = txtIP.get()
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    #ssh.connect(ip_address, username='root', password='toor')
    ssh.connect(ip_address, username=txtUID.get(), password=txtPW.get())
    stdin, stdout, stderr = ssh.exec_command('service lte restart')
    time.sleep(2) 
    ssh.close()
    
    root.config(cursor="")
    root.update()  # force update of screen
 

# Event Handler for 'Service Stop' button on tabUEsim
# ssh to the target ip (txtIP) and execute the command 'service lte stop'
def lteServiceStop_uesim(txtIP):

    root.config(cursor="watch")
    root.update()  # force update of screen

    ip_address = txtIP.get()
    uid = txtUID_Uesim.get()
    pw = txtPW_Uesim.get()
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    #ssh.connect(ip_address, username='root', password='toor')
    ssh.connect(ip_address, username=uid, password=pw)
    stdin, stdout, stderr = ssh.exec_command('service lte stop')
    time.sleep(2) 
    ssh.close()

    root.config(cursor="")
    root.update()  # force update of screen


# Event Handler for 'Service Restart' button on tabUEsim
# ssh to the target ip (txtIP) and execute the command 'service lte restart'
def lteServiceRestart_uesim(txtIP):

    root.config(cursor="watch")
    root.update()  # force update of screen

    ip_address = txtIP.get()
    uid = txtUID_Uesim.get()
    pw = txtPW_Uesim.get()
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    #ssh.connect(ip_address, username='root', password='toor')
    ssh.connect(ip_address, username=uid, password=pw)
    stdin, stdout, stderr = ssh.exec_command('service lte restart')
    time.sleep(2) 
    ssh.close()
    
    root.config(cursor="")
    root.update()  # force update of screen


# Event handler for 'Send' button on Tab1
# send RemoteAPI command set in txtCommand textbox and print the response to txtReturn textbox. 
# this construct target url from txtIP textbox and cboPort combobox
def send_command():    
    try:
        # Construct strIP from txtIP and comPort value
        strIP = txtIP.get() + ":" + str(cboPort.get())
        ws = create_connection("ws://" + strIP)

        # strMsg is the value of txtCommand
        strMsg = txtCommand.get("1.0", "end-1c")
        ws.send(strMsg)

        txtReturn.delete("1.0", "end")

        while True:
            result = ws.recv()
            if result:
                message = json.loads(result)
                pretty_message = json.dumps(message, indent=2)
                txtReturn.insert("end", pretty_message)
                if message.get("message") != "ready":
                    break

        ws.close()

    except Exception as e:
        txtReturn.delete("1.0", "end")
        error_message =  str(e)
        tk.messagebox.showerror("Error", error_message)



# Event handler for 'Send' button on Tab1
# send RemoteAPI command set in txtCommand textbox and print the response to txtReturn textbox. 
# this construct target url from txtIP textbox and cboPort combobox
def send_command_uesim():    

    try:
        # Construct strIP from txtIP and comPort value
        strIP = txtIP_uesim.get() + ":" + str(cboPort_uesim.get())
        ws = create_connection("ws://" + strIP)

        # strMsg is the value of txtCommand
        strMsg = txtCommand_uesim.get("1.0", "end-1c")
        ws.send(strMsg)

        txtReturn_uesim.delete("1.0", "end")

        while True:
            result = ws.recv()
            if result:
                message = json.loads(result)
                pretty_message = json.dumps(message, indent=2)
                txtReturn_uesim.insert("end", pretty_message)
                if message.get("message") != "ready":
                    break

        ws.close()

    except Exception as e:
        txtReturn_uesim.delete("1.0", "end")
        error_message =  str(e)
        tk.messagebox.showerror("Error", error_message)


# event hadnler for btnPhyDL Button('Set' button in DL PHY schedule).  
def process_btnPhyDL():

    root.config(cursor="watch")
    root.update()  # force update of screen

    txtCommand.delete("1.0", tk.END)  # Delete current text in entry
    
    cmdStr = f'{{"message": "config_set", "cells": {{"{txtForceDlScheduleCells.get()}":{{"pdsch_fixed_rb_start":{txtForceDlScheduleRbStart.get()}, "pdsch_fixed_l_crb":{txtForceDlScheduleRbN.get()} ,"pdsch_mcs":{txtForceDlScheduleMCS.get()} '
    if chkVarForceDlSchedule.get() == True:
        cmdStr = cmdStr + ', ' +  '"force_dl_schedule":true'
    else :
        cmdStr = cmdStr + ', ' +  '"force_dl_schedule":false'

    if chkVarPdschFixedRbAlloc.get() == True:
        cmdStr = cmdStr + ', ' +  '"pdsch_fixed_rb_alloc":true' 
    else :
        cmdStr = cmdStr + ', ' +  '"pdsch_fixed_rb_alloc":false' 

    cmdStr = cmdStr + ' ' + '} } }'
    txtCommand.delete("1.0", tk.END) 
    txtCommand.insert("1.0", cmdStr )
    send_command()
        
    root.config(cursor="")


# event hadnler for btnPhyUL Button('Set' button in UL PHY schedule).  
def process_btnPhyUL():

    root.config(cursor="watch")
    root.update()  # force update of screen

    txtCommand.delete("1.0", tk.END)  # Delete current text in entry
    
    cmdStr = f'{{"message": "config_set", "cells": {{"{txtForceFullBsrCells.get()}":{{"pusch_fixed_rb_start":{txtForceFullBsrRbStart.get()}, "pusch_fixed_l_crb":{txtForceFullBsrRbN.get()} ,"pusch_mcs":{txtForceFullBsrMCS.get()} '
    
    if chkVarForceFullBsr.get() == True:
        cmdStr = cmdStr + ', ' +  '"force_full_bsr":true'
    else:
        cmdStr = cmdStr + ', ' +  '"force_full_bsr":false'

    if chkVarPuschFixedRbAlloc.get() == True:
        cmdStr = cmdStr + ', ' +  '"pusch_fixed_rb_alloc":true'  
    else:    
        cmdStr = cmdStr + ', ' +  '"pusch_fixed_rb_alloc":false'  

    cmdStr = cmdStr + ' ' + '} } }'
    txtCommand.delete("1.0", tk.END) 
    txtCommand.insert("1.0", cmdStr )
    send_command()
        
    root.config(cursor="")


# event hadnler for btnInactivityTimer Button('Set' button in InactivityTimer setting frame).
def process_btnInactivityTimer():

    root.config(cursor="watch")
    root.update()  # force update of screen
    
    txtCommand.delete("1.0", tk.END) 
    txtCommand.insert("1.0", f'{{"message":"config_set","cells": {{"{txtInactivityTimerCells.get()}":{{"inactivity_timer":{ txtInactivityTimer.get()} }} }} }} ')
    send_command()
    
    root.config(cursor="")


# event hadnler for btnTxGain Button('Set' button in Tx Gain setting frame). it sends 'tx_gain' RemoteAPI comman. 
#    If 'All' option is checked, 'tx_gain : value' command is sent
#    If 'All' option is not checked, 'tx_gain : [tx1, tx2,...]' command is sent
def process_btnTxGain():

    root.config(cursor="watch")
    root.update()  # force update of screen

    txtCommand.delete("1.0", tk.END)  # Delete current text in entry
    
    txgains = getTxport()

    if chkVarTxGainAll.get() == False:
        txgains_string = ', '.join(str(var.get()) for var in spinVarTxGain[0:len(txgains)])
        txtCommand.delete("1.0", tk.END) 
        txtCommand.insert("1.0", f'{{"message":"rf","tx_gain":[ {txgains_string}]}}')
        send_command()
        
    root.config(cursor="")


# event hadnler for btnRxGain Button('Set' button in Rx Gain setting frame). it sends 'tx_gain' RemoteAPI comman. 
#    If 'All' option is checked, 'rx_gain : value' command is sent
#    If 'All' option is not checked, 'rx_gain : [rx1, rx2,...]' command is sent
def process_btnRxGain():

    root.config(cursor="watch")
    root.update()  # force update of screen

    txtCommand.delete("1.0", tk.END)  # Delete current text in entry
    
    rxgains = getRxport()

    if chkVarRxGainAll.get() == False:
        rxgains_string = ', '.join(str(var.get()) for var in spinVarRxGain[0:len(rxgains)])
        txtCommand.delete("1.0", tk.END) 
        txtCommand.insert("1.0", f'{{"message":"rf","rx_gain":[ {rxgains_string}]}}')
        send_command()
    root.config(cursor="")


# event hadnler for btnTxGain Button('Set' button in Tx Gain setting frame). it sends 'tx_gain' RemoteAPI comman. 
#    If 'All' option is checked, 'tx_gain : value' command is sent
#    If 'All' option is not checked, 'tx_gain : [tx1, tx2,...]' command is sent
def process_btnTxGain_uesim():

    root.config(cursor="watch")
    root.update()  # force update of screen

    txtCommand_uesim.delete("1.0", tk.END)  # Delete current text in entry
    
    txgains = getTxport_uesim()

    if chkVarTxGainAll_uesim.get() == False:
        txgains_string = ', '.join(str(var.get()) for var in spinVarTxGain_uesim[0:len(txgains)])
        txtCommand_uesim.delete("1.0", tk.END) 
        txtCommand_uesim.insert("1.0", f'{{"message":"rf","tx_gain":[ {txgains_string}]}}')
        send_command_uesim()
        
    root.config(cursor="")


# event hadnler for btnRxGain Button('Set' button in Rx Gain setting frame). it sends 'tx_gain' RemoteAPI comman. 
#    If 'All' option is checked, 'rx_gain : value' command is sent
#    If 'All' option is not checked, 'rx_gain : [rx1, rx2,...]' command is sent
def process_btnRxGain_uesim():

    root.config(cursor="watch")
    root.update()  # force update of screen

    txtCommand_uesim.delete("1.0", tk.END)  # Delete current text in entry
    
    rxgains = getRxport_uesim()

    if chkVarRxGainAll_uesim.get() == False:
        rxgains_string = ', '.join(str(var.get()) for var in spinVarRxGain_uesim[0:len(rxgains)])
        txtCommand_uesim.delete("1.0", tk.END) 
        txtCommand_uesim.insert("1.0", f'{{"message":"rf","rx_gain":[ {rxgains_string}]}}')
        send_command_uesim()
    root.config(cursor="")


# this is to set Rx gain with TxAllValue and then saves the return TxGain value from the response
# main purpose is to figure out the number of configured TxPorts
def getTxport():

    txtCommand.delete("1.0", tk.END)  # Delete current text in entry
    tx_gain_value = txtTxGain.get()
    txtCommand.insert("1.0", f'{{"message":"rf","tx_gain": {tx_gain_value} }}')
    send_command()
    contents = txtReturn.get("1.0", tk.END).strip()
    contents = contents.replace('\n', '')

    if not contents:
        tk.messagebox.showerror("Empty txtReturn", "txtReturn is empty. Please provide valid input.")
        return
    
    json_objects = find_json_objects_as_object(contents)
    #print(json_objects)
    return json_item_get_as_object(json_objects, 'tx_gain') 


# this is to set Rx gain with RxAllValue and then saves the return RxGain value from the response
# main purpose is to figure out the number of configured RxPorts
def getRxport():

    txtCommand.delete("1.0", tk.END)  
    rx_gain_value = txtRxGain.get()
    txtCommand.insert("1.0", f'{{"message":"rf","rx_gain": {rx_gain_value} }}')
    send_command()
    contents = txtReturn.get("1.0", tk.END).strip()
    contents = contents.replace('\n', '')

    if not contents:
        tk.messagebox.showerror("Empty txtReturn", "txtReturn is empty. Please provide valid input.")
        return
    
    json_objects = find_json_objects_as_object(contents)
    #print(json_objects)
    return json_item_get_as_object(json_objects, 'rx_gain') 


# this is to set Rx gain with TxAllValue and then saves the return TxGain value from the response
# main purpose is to figure out the number of configured TxPorts
def getTxport_uesim():

    txtCommand_uesim.delete("1.0", tk.END)  # Delete current text in entry
    tx_gain_value = txtTxGain_uesim.get()
    txtCommand_uesim.insert("1.0", f'{{"message":"rf","tx_gain": {tx_gain_value} }}')
    send_command_uesim()
    contents = txtReturn_uesim.get("1.0", tk.END).strip()
    contents = contents.replace('\n', '')

    if not contents:
        tk.messagebox.showerror("Empty txtReturn", "txtReturn is empty. Please provide valid input.")
        return
    
    json_objects = find_json_objects_as_object(contents)
    #print(json_objects)
    return json_item_get_as_object(json_objects, 'tx_gain') 


# this is to set Rx gain with RxAllValue and then saves the return RxGain value from the response
# main purpose is to figure out the number of configured RxPorts
def getRxport_uesim():

    txtCommand_uesim.delete("1.0", tk.END)  
    rx_gain_value = txtRxGain_uesim.get()
    txtCommand_uesim.insert("1.0", f'{{"message":"rf","rx_gain": {rx_gain_value} }}')
    send_command_uesim()
    contents = txtReturn_uesim.get("1.0", tk.END).strip()
    contents = contents.replace('\n', '')

    if not contents:
        tk.messagebox.showerror("Empty txtReturn", "txtReturn is empty. Please provide valid input.")
        return
    
    json_objects = find_json_objects_as_object(contents)
    #print(json_objects)
    return json_item_get_as_object(json_objects, 'rx_gain') 


# this is to get the value of specific items from JSON and return it as JSON object
def json_item_get_as_object(json_object_list, json_item_path):
    item_path_parts = json_item_path.split('.')
    for json_object in json_object_list:
        try:
            item = json_object
            for part in item_path_parts:
                if part.isdigit():
                    item = item[int(part)]
                else:
                    item = item[part]  
            if item:  # if the item is found, return it
                return item
        except (KeyError, TypeError):
            pass  # ignore if key or type error and continue with the next json object

    # print error if the item was not found in any json object
    print(f"Could not access {json_item_path} in any item")


# Following 3 functions are to display json_object to treeview. 
def display_json_objects(tree, json_objects):
    # Clear the previous contents of the TreeView
    for row in tree.get_children():
        tree.delete(row)

    # Clear columns
    tree['columns'] = []

    # Reset the "#0" column
    tree.column("#0", width=200, stretch=True)
    
    # Traverse through json objects and display
    for i, obj in enumerate(json_objects):
        parent = ''
        if isinstance(obj, dict):
            parent = tree.insert(parent, 'end', text='Object')
            display_dict(tree, parent, obj)
        elif isinstance(obj, list):
            parent = tree.insert(parent, 'end', text='Array')
            display_list(tree, parent, obj)

def display_dict(tree, parent, d):
    for key, value in d.items():
        node = tree.insert(parent, 'end', text=key)
        if isinstance(value, dict):
            display_dict(tree, node, value)
        elif isinstance(value, list):
            display_list(tree, node, value)
        else:
            tree.insert(node, 'end', text=value)

def display_list(tree, parent, l):
    for i, item in enumerate(l):
        node = tree.insert(parent, 'end', text=i)
        if isinstance(item, dict):
            display_dict(tree, node, item)
        elif isinstance(item, list):
            display_list(tree, node, item)
        else:
            tree.insert(node, 'end', text=item)



# Event Handler for 'Process' button on tab1, It displays the contents of txtReturn (JSON format) in tblProcess in tree or tabular format
#    It displays the contents in tabular format if txtReturn contains the log_get output
#    It displays the contents in tree format if txtReturn contains the output of any other command
def process_txtReturn():    

    global df, tblProcess, txtReturn

    root.config(cursor="watch")
    root.update()  # force update of screen

    tblProcess.delete(*tblProcess.get_children())

    contents = txtReturn.get("1.0", tk.END).strip()
    contents = contents.replace('\n', '')

    if not contents:
        tk.messagebox.showerror("Empty txtReturn", "txtReturn is empty. Please provide valid input.")
        return

    # split contents into individual JSON objects
    json_objects = find_json_objects(contents)

    # validate each JSON object
    valid_json_objects = []
    for json_str in json_objects:
        try:
            json_obj = json.loads(json_str)
            valid_json_objects.append(json_obj)
        except ValueError:
            #print("Error", "Invalid JSON format: {}".format(json_str))
            continue

    # display the JSON objects in a table
    display_json_objects(tblProcess, valid_json_objects)

    # Hide the first item of the tree because it is just the indicator of 'message = ready'
    item_id = tblProcess.get_children()[0]
    tblProcess.detach(item_id)

    #tblProcess.column('Value', anchor='w')
    # Expand the objects to the first level 
    ExpandLevel1(tblProcess)
     
    # Save the contents of txtReturn to a temp file : temp.log 
    contents = txtReturn.get('1.0', 'end')  # Get the contents of the text box
    contents = '[\n' + contents.replace('}{', '},\n{') + ']'

    if "log_get" in contents:  # Check if the string 'log_get' is in the contents
        with open('temp.log', 'w') as f:
            f.write(contents)  # Write the contents to the file 'temp.log'
        #df = log2panda('temp.log')
        df = log2panda_ijson('temp.log')
        #print(df)

        # Clear the previous contents of the TreeView
        for row in tblProcess.get_children():
            tblProcess.delete(row)

        # Delete old columns
        for column in tblProcess["columns"]:
            tblProcess.column(column, width=0)
            tblProcess.heading(column, text='')

        # Set new columns
        columns = df.columns.tolist()
        tblProcess["columns"] = columns
        for i, column in enumerate(columns):
            if i == 0:  # First column
                tblProcess.column(column, width=50)
            elif i == len(columns) - 1:  # Last column
                tblProcess.column(column, width=600)
            else:
                tblProcess.column(column, width=100)  # Set width as needed
            tblProcess.heading(column, text=column)

        # Add new rows
        for index, row in df.iterrows():
            tblProcess.insert('', 'end', values=row.tolist())

        tblProcess.column("#0", width=0, stretch=False)

    root.config(cursor="")
    root.update()  # force update of screen


# Event handler for 'Update Log' button on Tab2
#   i) sends 'log_get' command and get the result
#   ii) execute process_txtReturn() to save the result into a JSON text file (temp.log) and convert the temp.log into a panda dataframe (df)
#   iii) extract RRC / NAS layer log from df
#   iv) display the result in tblLogUpdate on tab2
def process_LogUpdate():    

    root.config(cursor="watch")
    root.update()  # force update of screen

    txtCommand.delete("1.0", tk.END)  # Delete current text in entry
    txtCommand.insert("1.0", '{"message":"log_get"}')
    send_command()
    process_txtReturn()

    # Filter DataFrame
    df_filtered = df[df['layer'].isin(["RRC", "NAS"])]
    
    # clear the table
    for row in tblLogUpdate.get_children():
        tblLogUpdate.delete(row)
    
    tblLogUpdate.column('data', anchor='w')
    
    # Add rows to the table from the DataFrame
    for index, row in df_filtered.iterrows():
        # get only the first line of the data column
        data_first_line = str(row['data']).split('\n')[0] if '\n' in str(row['data']) else row['data']
        tblLogUpdate.insert("", "end", values=(row['layer'], row['dir'], row['ue_id'], row['cell'], data_first_line))

    root.config(cursor="")
    root.update()  # force update of screen


# Event handler for 'Log Clear' button on tab2
def process_LogClear():

    for row in tblLogUpdate.get_children():
        tblLogUpdate.delete(row)



# event hadnler for btnPowerOn_uesim Button.  
def process_btnPowerOn_uesim():

    root.config(cursor="watch")
    root.update()  # force update of screen

    txtCommand_uesim.delete("1.0", tk.END)  # Delete current text in entry
    
    cmdStr = f'{{"message": "power_on", "ue_id": 1 }}'

    txtCommand_uesim.delete("1.0", tk.END) 
    txtCommand_uesim.insert("1.0", cmdStr )
    send_command_uesim()
        
    root.config(cursor="")


# event hadnler for btnPowerOff_uesim Button.  
def process_btnPowerOff_uesim():

    root.config(cursor="watch")
    root.update()  # force update of screen

    txtCommand_uesim.delete("1.0", tk.END)  # Delete current text in entry
    
    cmdStr = f'{{"message": "power_off", "ue_id": 1 }}'

    txtCommand_uesim.delete("1.0", tk.END) 
    txtCommand_uesim.insert("1.0", cmdStr )
    send_command_uesim()
        
    root.config(cursor="")   

# Extract all valid JSON objects from a given text string. The text can contain multiple JSON objects possibly mixed with other text.
# It works by counting the number of open braces ('{') and close braces ('}') encountered as it iterates over each character in the text string. 
# When an open brace is found, it checks if it's the beginning of a new JSON object. When a close brace is found, it checks if it's the end of a current JSON object.
# It stores the start and end indices of each valid JSON object and appends the corresponding substrings of the text to the json_objects list, 
# which is returned at the end of the function. These substrings represent individual JSON objects.
#
def find_json_objects(text):
    json_objects = []
    open_braces = 0
    json_start = -1

    for idx, char in enumerate(text):
        if char == '{':
            if open_braces == 0:
                json_start = idx
            open_braces += 1
        elif char == '}':
            open_braces -= 1
            if open_braces == 0:
                json_objects.append(text[json_start:idx+1])

    return json_objects


# extract all JSON objects from a given string, parse them using json.loads() into Python dictionaries, and return them as a list.
# Like its counterpart find_json_objects(), it iterates through each character of the string, tracking the count of open and close braces to 
# find the start and end of each JSON object. But here, each JSON object is immediately converted to a Python dictionary.
# The resulting list of Python dictionaries, json_objects, is returned at the end. Each dictionary in the list represents an individual JSON 
# object parsed from the input string.
#
def find_json_objects_as_object(text):
    json_objects = []
    open_braces = 0
    json_start = -1

    for idx, char in enumerate(text):
        if char == '{':
            if open_braces == 0:
                json_start = idx
            open_braces += 1
        elif char == '}':
            open_braces -= 1
            if open_braces == 0:
                json_string = text[json_start:idx+1]
                json_object = json.loads(json_string)
                json_objects.append(json_object)

    return json_objects


# this is to convert a JSON file into panda dataframe. In this function, json package is used instead of ijson package.
# json package is easier to use but would cause various issues with handling large / complicated JSON like the log_get output. 
def log2panda(log_filename: str):
    column_names = ['src', 'idx', 'level', 'timestamp', 'layer', 'dir', 'ue_id', 'cell', 'rnti', 'frame', 'slot', 'channel', 'data']
    data = []

    # Detect the file encoding
    with open(log_filename, 'rb') as log_file:
        encoding_result = chardet.detect(log_file.read())
    file_encoding = encoding_result['encoding']

    # Open the file with the detected encoding
    with open(log_filename, 'r', encoding=file_encoding) as log_file:
        content = log_file.read()
        json_objects = find_json_objects(content)
        row = []

        for json_object in json_objects:
            try:
                log_json = json.loads(json_object)

                if "logs" in log_json:
                    logs = log_json["logs"]
                else:
                    logs = [log_json]

                for log in logs:
                    if log.get("message") != "ready":
                        row = []
                        for column in column_names:
                            cell_value = log.get(column)
                            if column == 'data' and isinstance(cell_value, list):
                                cell_value = '\n'.join(cell_value)
                            if cell_value is not None:
                                if column == 'data':
                                    cell_value = cell_value.replace('\\r\\n', '<br>&nbsp;;')
                                    cell_value = cell_value.replace('\\t', '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;')
                                cell_value = str(cell_value).replace('"', '')
                            else:
                                cell_value = ' '
                            row.append(cell_value)
                        data.append(row)
            except json.JSONDecodeError:
                print("Malformed row : ", row)
                continue

    df = pd.DataFrame(data, columns=column_names)
    return df


# this is to convert a JSON file into panda dataframe. In this function, ijson package is used instead of json package.
# ijson package is better for handling large / complicated JSON (e.g, log_get output) comparing to json package
def log2panda_ijson(log_filename: str):
    column_names = ['src', 'idx', 'level', 'timestamp', 'layer', 'dir', 'ue_id', 'cell', 'rnti', 'frame', 'slot', 'channel', 'data']
    data = []

    # Detect the file encoding
    with open(log_filename, 'rb') as log_file:
        encoding_result = chardet.detect(log_file.read())
    file_encoding = encoding_result['encoding']


    # Open the file with the detected encoding
    with open(log_filename, 'r', encoding=file_encoding) as log_file:
        json_objects = ijson.items(log_file, 'item.logs.item')

        for log in json_objects:
            if log.get("message") != "ready":
                row = []
                for column in column_names:
                    cell_value = log.get(column)
                    if column == 'data' and isinstance(cell_value, list):
                        cell_value = '\n'.join(cell_value)
                    if cell_value is not None:
                        if column == 'data':
                            cell_value = cell_value.replace('\\r\\n', '<br>&nbsp;;')
                            cell_value = cell_value.replace('\\t', '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;')
                        cell_value = str(cell_value).replace('"', '')
                    else:
                        cell_value = ' '
                    row.append(cell_value)
                data.append(row)

    df = pd.DataFrame(data, columns=column_names)
    return df


# Followings are event handler for the buttons on Tab1 : Expand All, Collapse All, Expand Level 1
def ExpandAll(tree):
    for item in tree.get_children():
        tree.item(item, open=True)
        _expand_all_children(tree, item)


def _expand_all_children(tree, item):
    for child in tree.get_children(item):
        tree.item(child, open=True)
        _expand_all_children(tree, child)


def CollapseAll(tree):
    for item in tree.get_children():
        tree.item(item, open=False)
        _collapse_all_children(tree, item)


def _collapse_all_children(tree, item):
    for child in tree.get_children(item):
        tree.item(child, open=False)
        _collapse_all_children(tree, child)


def ExpandLevel1(tree):
    for item in tree.get_children():
        tree.item(item, open=True)
        for child in tree.get_children(item):
            tree.item(child, open=False)

# this is Event handler for 'Download' button on File Browser tab. this is to download(copy) the selected file from the remote PC (fileview on the right pannel) to
# the current directory on the local PC (fileview on the left panel)
def process_Download(p_fb, p_fbSCP):
    remote_file_path = p_fbSCP.selectedFile  # The selected file on the remote PC
    local_directory_path = p_fb.path  # The directory on the local PC

    try:
        # If symbolic link, parse the remote_file_path to get the actual linked file path
        match = re.search(r'(.*?) -> (.*)', remote_file_path)
        if match:
            source, target = match.groups()
            if not posixpath.isabs(target):  # if target is not an absolute path
                remote_file_path = posixpath.join(posixpath.dirname(source), target)
            else:
                remote_file_path = target

        file_name = os.path.basename(remote_file_path)
        local_file_path = os.path.join(local_directory_path, file_name)

        p_fbSCP.sftp_client.get(remote_file_path, local_file_path)
        p_fb.update_file_list()

        print(f"File {remote_file_path} has been downloaded to {local_file_path}.")
    except FileNotFoundError:
        print(f"The file does not exist: {remote_file_path}")
        return
    except Exception as e:
        print(f"An error occurred while accessing the file: {remote_file_path}")
        print(f"Error details: {str(e)}")
        return


# this is Event handler for 'Upload' button on File Browser tab. this is to upload(copy) the selected file from the local PC (fileview on the left pannel) to
# the current directory on the remote PC (fileview on the right panel)
def process_Upload(p_fb,p_fbSCP):
    remote_path = p_fbSCP.path  # The current path on the remote PC
    local_file_path = p_fb.selectedFile  # The selected file on the local PC

    try:
        file_name = os.path.basename(local_file_path)
        remote_file_path = posixpath.join(remote_path, file_name)

        p_fbSCP.sftp_client.put(local_file_path, remote_file_path)
        p_fbSCP.update_file_list()

        print(f"File {local_file_path} has been uploaded to {remote_file_path}.")
    except FileNotFoundError:
        print(f"The file does not exist: {local_file_path}")
        return
    except Exception as e:
        print(f"An error occurred while accessing the file: {local_file_path}")
        print(f"Error details: {str(e)}")
        return


class SimpleNotepad:

    def __init__(self, file_path):
        self.root = tk.Toplevel()  # Create a new window
        self.file_path = file_path
        self.text_area = tk.Text(self.root)
        self.remote_ip = None
        self.remote_username = None
        self.remote_password = None
        self.system = "LOCAL"

        # Menus
        self.create_menus()
        
        # Toolbar
        self.create_toolbars()
        
        # Text Area
        self.create_text_area()

         # Create context menu with 'copy' and 'paste' commands
        self.context_menu = tk.Menu(self.root, tearoff=0)
        self.context_menu.add_command(label="Copy", command=self.copy_text)
        self.context_menu.add_command(label="Paste", command=self.paste_text)

        self.text_area.bind("<Button-3>", self.show_context_menu)


    def open(self):
        with open(self.file_path, 'r') as f:
            file_contents = f.read()
        self.text_area.insert('1.0', file_contents)
        self.root.mainloop()

    
    def open_remote(self):
        ssh = paramiko.SSHClient()
        ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
        ssh.connect(self.remote_ip, username=self.remote_username, password=self.remote_password)

        sftp = ssh.open_sftp()
        with sftp.file(self.file_path, 'r') as f:
            file_contents = f.read()
        self.text_area.insert('1.0', file_contents)
        self.root.mainloop()

        sftp.close()
        ssh.close()    

    def create_menus(self):
        menu = tk.Menu(self.root)
        self.root.config(menu=menu)

        # File Menu
        file_menu = tk.Menu(menu, tearoff=0)
        menu.add_cascade(label="File", menu=file_menu)
        file_menu.add_command(label="New", command=self.new_file)
        file_menu.add_command(label="Open", command=self.open_file)
        file_menu.add_command(label="Save", command=self.save_file)
        file_menu.add_command(label="Save As", command=self.save_as_file)
        file_menu.add_command(label="Exit", command=self.exit_app)

        # Edit Menu
        edit_menu = tk.Menu(menu, tearoff=0)
        menu.add_cascade(label="Edit", menu=edit_menu)
        edit_menu.add_command(label="Cut", command=self.cut_text)
        edit_menu.add_command(label="Copy", command=self.copy_text)
        edit_menu.add_command(label="Paste", command=self.paste_text)
        edit_menu.add_command(label="Del", command=self.del_text)

        # Search Menu
        search_menu = tk.Menu(menu, tearoff=0)
        menu.add_cascade(label="Search", menu=search_menu)
        search_menu.add_command(label="Find", command=self.find_text)
        search_menu.add_command(label="Replace", command=self.replace_text)

    def create_toolbars(self):
        toolbar = tk.Frame(self.root)

        # Add a label
        lbl_quick_search = tk.Label(toolbar, text="Quick Search")
        lbl_quick_search.pack(side="left", padx=(10, 2))

        # Add a combo box
        self.cboFrequentKeyword = ttk.Combobox(toolbar)
        self.cboFrequentKeyword.pack(side="left", padx=(0, 10))

        # Add a search button
        btnSearch = ttk.Button(toolbar, text="Search", command=self.find_text)
        btnSearch.pack(side="left", padx=(0, 2))

        # Add a 'cell_list' button
        self.cell_list = ttk.Button(toolbar, text="cell_list", command=lambda: self.find_string("cell_list"))
        self.cell_list.pack(side="left", padx=(10, 0))

        # Add a 'arfcn' button
        self.arfcn = ttk.Button(toolbar, text="arfcn", command=lambda: self.find_string("arfcn"))
        self.arfcn.pack(side="left", padx=(0, 0))
        

        toolbar.pack(side="top", fill="x", pady=(5,0))

    def create_text_area(self):
        frame = tk.Frame(self.root)
        frame.pack(fill="both", expand=True)

        # create vertical scrollbar
        self.vert_scrollbar = tk.Scrollbar(frame, orient="vertical")
        self.vert_scrollbar.pack(side="right", fill="y")

        # create horizontal scrollbar
        self.horiz_scrollbar = tk.Scrollbar(frame, orient="horizontal")
        self.horiz_scrollbar.pack(side="bottom", fill="x")

        # create text area with scrollbars
        self.text_area = tk.Text(frame, wrap="none", undo=True, 
                                yscrollcommand=self.vert_scrollbar.set, 
                                xscrollcommand=self.horiz_scrollbar.set)
        self.text_area.pack(side="left", fill="both", expand=True)

        # configure scrollbars to move with text area
        self.vert_scrollbar.config(command=self.text_area.yview)
        self.horiz_scrollbar.config(command=self.text_area.xview)
    

    def create_context_menu(self):
        self.context_menu = tk.Menu(self.root, tearoff=0)
        self.context_menu.add_command(label="Copy", command=self.copy_text)
        self.context_menu.add_command(label="Paste", command=self.paste_text)


    def show_context_menu(self, event):
        self.context_menu.tk_popup(event.x_root, event.y_root)


    def copy_text(self):
        selected = self.text_area.get(tk.SEL_FIRST, tk.SEL_LAST)
        self.root.clipboard_clear()
        self.root.clipboard_append(selected)

    def paste_text(self):
        self.text_area.insert(tk.INSERT, self.root.clipboard_get())
        

    def new_file(self):
        self.text_area.delete("1.0", tk.END)
        self.file_path = None

    def open_file(self):
        self.file_path = filedialog.askopenfilename(defaultextension=".txt", filetypes=[("All Files", "*.*"), ("Text Documents", "*.txt")])
        if self.file_path == "":
            # No file to open
            return
        else:
            self.text_area.delete(1.0, tk.END)
            with open(self.file_path, "r") as file:
                self.text_area.insert(1.0, file.read())

    def save_file(self):
        if self.system == "LOCAL":
            self.save_file_local()
        else:
            self.save_file_remote()

    def save_file_local(self):
        if self.file_path is None:
            self.save_as_file()
        else:
            content = self.text_area.get(1.0, tk.END)
            with open(self.file_path, "w") as file:
                file.write(content)

    def save_file_remote(self):
        ssh = paramiko.SSHClient()
        ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
        ssh.connect(self.remote_ip, username=self.remote_username, password=self.remote_password)

        sftp = ssh.open_sftp()
        content = self.text_area.get(1.0, tk.END)
        with sftp.file(self.file_path, 'w') as f:
            f.write(content)

        sftp.close()
        ssh.close()

    def save_as_file(self):
        if self.system == "LOCAL":
            self.save_as_file_local()
        else:
            self.save_as_file_remote()  

    def save_as_file_local(self):
        self.file_path = filedialog.asksaveasfilename(defaultextension=".txt", filetypes=[("All Files", "*.*"), ("Text Documents", "*.txt")])
        print(self.file_path)
        if self.file_path == "":
            # No file to save
            return
        else:
            content = self.text_area.get(1.0, tk.END)
            with open(self.file_path, "w") as file:
                file.write(content)
                print(f"File {self.file_path} has been saved.")

    def save_as_file_remote(self):
        ssh = paramiko.SSHClient()
        ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
        ssh.connect(self.remote_ip, username=self.remote_username, password=self.remote_password)

        root = tk.Tk()
        root.withdraw()  # Hide the main window.
        # Ask the user for the full path on the remote system.
        current_dir = os.path.dirname(self.file_path) if self.file_path else ''
        self.file_path = simpledialog.askstring("Input", "Enter the full path (directory and filename) on the remote system", initialvalue=current_dir)
        sftp = ssh.open_sftp()
        content = self.text_area.get(1.0, tk.END)
        with sftp.file(self.file_path, 'w') as f:
            f.write(content)

        sftp.close()
        ssh.close()

    def exit_app(self):
        self.root.destroy()

    def cut_text(self):
        self.text_area.event_generate(("<<Cut>>"))

    def copy_text(self):
        self.text_area.event_generate(("<<Copy>>"))

    def paste_text(self):
        self.text_area.event_generate(("<<Paste>>"))

    def del_text(self):
        start = self.text_area.index('sel.first')
        end = self.text_area.index('sel.last')
        self.text_area.delete(start, end)

    def find_text(self):
        find_string = simpledialog.askstring("Find...", "Enter text")

        # Remove any previous 'found' tags
        self.text_area.tag_remove("found", "1.0", tk.END)

        self.find_string(find_string)


    def find_string(self, find_string):

        # If a non-empty string was entered
        if find_string:
            idx = "1.0"
            while True:
                # Search for the string from 'idx' to the end
                idx = self.text_area.search(find_string, idx, nocase=1, stopindex=tk.END)
                if not idx: 
                    break

                # Found the string, create an end index by adding
                # (as a string) the length of the search string to the start idx
                end = f"{idx}+{len(find_string)}c"

                # Add the 'found' tag to the start and end indices
                self.text_area.tag_add("found", idx, end)
                
                # Move cursor to the start of found string
                self.text_area.mark_set("insert", idx)
                self.text_area.see("insert")

                # Move the idx to continue the search after the current match
                idx = end

            # Configure the 'found' tag to have a yellow background
            self.text_area.tag_config("found", background="yellow")
        else:
            messagebox.showinfo("Results", "Enter a text to find")

    def replace_text(self):
        find_string = simpledialog.askstring("Find...", "Enter text")
        replace_string = simpledialog.askstring("Replace with...", "Enter text")
        text = self.text_area.get('1.0', tk.END)

        new_text = text.replace(find_string, replace_string)
        self.text_area.delete('1.0', tk.END)
        self.text_area.insert('1.0', new_text)

# Define Global Variables
df = None
root = None
txtIP = None
cboPort = None
txtUID = None
txtPW = None
txtUID_Uesim = None
txtPW_Uesim = None
txtCommand = None
txtReturn = None
tblProcess = None
tblLogUpdate = None
cboCommand = None
cboSubCommand = None
cboCellID  = None
cboUEID  = None
txtTxGain = None
txtRxGain = None
txtForceDlScheduleCells = None
txtForceDlScheduleMCS  = None
txtForceDlScheduleRbStart = None
txtForceDlScheduleRbN  = None
txtorceFullBsrCells  = None
txtorceFullBsrMCS   = None
txtorceFullBsrRbStart  = None
txtorceFullBsrRbN  = None
txtInactivityTimerCells = None
txtInactivityTimer  = None

chkVarTxGainAll = None
chkVarTxGainTx = []  
chkVarRxGainAll = None
chkVarRxGainRx = []  # create list to store IntVars
chkVarForceDlSchedule = None
chkVarPdschFixedRbAlloc = None
chkVarForceFullBsr = None
chkVarPuschFixedRbAlloc = None

spinVarTxGain = []
spinVarRxGain = []

txtIP_uesim = None
cboPort_uesim = None
txtCommand_uesim = None
txtReturn_uesim = None
tblProcess_uesim = None
tblLogUpdate_uesim = None
cboCommand_uesim = None
cboSubCommand_uesim = None
cboCellID_uesim  = None
cboUEID_uesim  = None
txtTxGain_uesim = None
txtRxGain_uesim = None

chkVarTxGainAll_uesim = None
chkVarTxGain_uesim = []  
chkVarRxGainAll_uesim = None
chkVarRxGain_uesim = []  # create list to store IntVars
chkVarForceDlSchedule_uesim = None
chkVarPdschFixedRbAlloc_uesim = None
chkVarForceFullBsr_uesim = None
chkVarPuschFixedRbAlloc_uesim = None

spinVarTxGain_uesim = []
spinVarRxGain_uesim = []

fb = None
fbSCP = None
fb_UEsim = None
fbSCP_UEsim = None


# main function
def main():

    global root
    global df, txtIP,txtUID, txtPW, cboPort,txtCommand,txtReturn,tblProcess,tblLogUpdate, cboCommand, cboSubCommand ,cboCellID, cboUEID
    global txtTxGain, txtRxGain, txtForceDlScheduleCells, txtForceDlScheduleMCS, txtForceDlScheduleRbStart, txtForceDlScheduleRbN
    global txtorceFullBsrCells, txtorceFullBsrMCS, txtorceFullBsrRbStart, txtorceFullBsrRbN , txtInactivityTimerCells, txtInactivityTimer
    global chkVarTxGainAll,chkVarTxGain,chkVarRxGainAll,chkVarRxGain,chkVarForceDlSchedule,chkVarPdschFixedRbAlloc,chkVarForceFullBsr,chkVarPuschFixedRbAlloc
    global spinVarTxGain, spinVarRxGain

    global txtIP_uesim,cboPort_uesim,txtCommand_uesim,txtReturn_uesim,tblProcess_uesim,tblLogUpdate_uesim, cboCommand_uesim, cboSubCommand_uesim, cboCellID_uesim, cboUEID_uesim
    global txtTxGain_uesim, txtRxGain_uesim
    global chkVarTxGainAll_uesim, chkVarTxGain_uesim, chkVarRxGainAll_uesim, chkVarRxGain_uesim
    global spinVarTxGain_uesim, spinVarRxGain_uesim

    global fb, fbSCP, fb_UEsim , fbSCP_UEsim 

    root = tk.Tk()
    root.title("Remote Control GUI")
    root.geometry("1200x600")
    root.grid_columnconfigure(0, weight=1)
    root.grid_rowconfigure(0, weight=1)
    root.config(cursor="")

    # Create a style object
    style = ttk.Style()

    # Modify the TNotebook.Tab style (this is the style for the tabs)
    style.configure('TNotebook.Tab', 
                    font=('Arial', '10', 'bold'), 
                    padding=[5, 10],  # [left/right padding, top/bottom padding]
                    )

    # Increase the size of the tabs to accommodate the new font size
    style.configure('TNotebook', tabposition='nw')  # 'n' is the default: 'n' (north), 's' (south), 'w' (west), 'e' (east)

    notebook = ttk.Notebook(root, style='TNotebook')
    notebook.grid(row=0, column=0, sticky="nsew")

    # Create a new frame for the first tab
    frmTab1 = ttk.Frame(notebook)
    #frmTab1.grid_columnconfigure(5, weight=1) # weight=0 --> not resizable, weight=1 --> resizable 
    #frmTab1.grid_columnconfigure(6, weight=1) # weight=0 --> not resizable, weight=1 --> resizable 
    #frmTab1.grid_columnconfigure(7, weight=1) # weight=0 --> not resizable, weight=1 --> resizable 
    frmTab1.grid_columnconfigure(8, weight=1) # weight=0 --> not resizable, weight=1 --> resizable 
    frmTab1.grid_rowconfigure(0, weight=0)  # weight=0 --> not resizable, weight=1 --> resizable 
    frmTab1.grid_rowconfigure(1, weight=0)  # weight=0 --> not resizable, weight=1 --> resizable 
    frmTab1.grid_rowconfigure(2, weight=0)  # weight=0 --> not resizable, weight=1 --> resizable 
    frmTab1.grid_rowconfigure(3, weight=0)  # weight=0 --> not resizable, weight=1 --> resizable 
    frmTab1.grid_rowconfigure(4, weight=0)  # weight=0 --> not resizable, weight=1 --> resizable 
    frmTab1.grid_rowconfigure(5, weight=0)  # weight=0 --> not resizable, weight=1 --> resizable 
    frmTab1.grid_rowconfigure(6, weight=0)  # weight=0 --> not resizable, weight=1 --> resizable 
    frmTab1.grid_rowconfigure(7, weight=0)  # weight=0 --> not resizable, weight=1 --> resizable 
    frmTab1.grid_rowconfigure(8, weight=1)  # weight=0 --> not resizable, weight=1 --> resizable 
    frmTab1.grid_rowconfigure(9, weight=0)  # weight=0 --> not resizable, weight=1 --> resizable 

    notebook.add(frmTab1, text="Callbox (I)")

    # Add your components to the first tab
    #create_row1(frmTab1,"10.0.0.185") # create txtIP, cboPort
    create_row1(frmTab1,"192.168.100.17") # create txtIP, cboPort
    create_row2(frmTab1) # create cboCellID, cboUEID
    create_row5(frmTab1) # create txtCommand
    create_row7(frmTab1) # create txtReturn
    create_row3(frmTab1) # create cboCommand, cboSubCommand
    create_row4(frmTab1) # create 
    create_row6(frmTab1) # create btnSend
    create_row9(frmTab1) # create tblProcess
    create_row8(frmTab1) # create btnProcess
    create_row10(frmTab1) # create btnExpandAll, btnCollapseAll,btnExpandLevel1
    create_row11(frmTab1) # create btnServiceStop,btnServiceRestart

    # Create a new frame for the second tab
    frmTab2 = ttk.Frame(notebook)
    frmTab2.grid_columnconfigure(0, weight=0)
    frmTab2.grid_rowconfigure(0, weight=0)
    notebook.add(frmTab2, text="Callbox (II)")

    chkVarTxGainAll = tk.IntVar(value=1)
    chkVarTxGain = []  # create list to store IntVars
    create_row1_tab2(frmTab2)
    chkVarRxGainAll = tk.IntVar(value=1)
    chkVarRxGain = []  # create list to store IntVars
    create_row2_tab2(frmTab2) # Create txtRxGain

    chkVarForceDlSchedule = tk.IntVar(value=0)
    chkVarPdschFixedRbAlloc = tk.IntVar(value=0)
    create_row3_tab2(frmTab2) # Create txtForceDlScheduleCells, txtForceDlScheduleMCS , txtForceDlScheduleRbStart, txtForceDlScheduleRbN

    chkVarForceFullBsr = tk.IntVar(value=0)
    chkVarPuschFixedRbAlloc = tk.IntVar(value=0)
    create_row4_tab2(frmTab2) # create txtorceFullBsrCells, txtorceFullBsrMCS , txtorceFullBsrRbStart, txtorceFullBsrRbN
    create_row5_tab2(frmTab2) # create txtInactivityTimer

    create_row7_tab2(frmTab2) # create tblLogUpdate 
    frmTab2.grid_rowconfigure(6, weight=1) # weight=0 --> not resizable, weight=1 --> not resizable 

    create_row6_tab2(frmTab2) # create btnUpdateLog, btnClearLog
    frmTab2.grid_columnconfigure(6, weight=1) # weight=0 --> not resizable, weight=1 --> not resizable 


    # Create a new frame for the third tab
    frmTabUEsim = ttk.Frame(notebook)
    frmTabUEsim.grid_columnconfigure(0, weight=0)
    frmTabUEsim.grid_rowconfigure(0, weight=0)
    notebook.add(frmTabUEsim, text="UEsim")

    #create_row1_tabUEsim(frmTabUEsim,"10.0.0.35") # create txtIP, cboPort
    create_row1_tabUEsim(frmTabUEsim,"192.168.100.15") # create txtIP, cboPort
    create_row2_tabUEsim(frmTabUEsim) # create cboCellID, cboUEID
    create_row3_tabUEsim(frmTabUEsim) # create txtCommand

    chkVarTxGainAll_uesim = tk.IntVar(value=1)
    chkVarTxGain_uesim = []  # create list to store IntVars
    create_row4_tabUEsim(frmTabUEsim) # Create RxGain Settings

    chkVarRxGainAll_uesim = tk.IntVar(value=1)
    chkVarRxGain_uesim = []  # create list to store IntVars
    create_row5_tabUEsim(frmTabUEsim) # Create RxGain Settings

    create_row6_tabUEsim(frmTabUEsim) # create btnPowerOn_uesim, btnPowerOff_uesim,
    create_row7_tabUEsim(frmTabUEsim) 
    create_row8_tabUEsim(frmTabUEsim) # create txtCommand_uesim 
    create_row9_tabUEsim(frmTabUEsim) # create btnSend_uesim
    create_row10_tabUEsim(frmTabUEsim) # create txtReturn_uesim
    create_row11_tabUEsim(frmTabUEsim) # create btnServiceStop_uesim, btnServiceRestart_uesim

    frmTabUEsim.grid_columnconfigure(5, weight=1) # weight=0 --> not resizable, weight=1 --> resizable 
    frmTabUEsim.grid_rowconfigure(10, weight=1) # weight=0 --> not resizable, weight=1 --> resizable 

    # Create a new frame for the File Browser
    frmTabFiles = ttk.Frame(notebook)
    frmTabFiles.grid_columnconfigure(0, weight=0)
    frmTabFiles.grid_rowconfigure(0, weight=0)
    notebook.add(frmTabFiles, text="File Browser(Callbox)")

    frameLeft, frameRight = create_frame_tabFiles(frmTabFiles)  # create three vertical frames on frmTabFiles
    fb = FileBrowser(master=frameLeft, path='C:\\') # create Local File Brwoser on frameLeft
    #fbSCP = FileBrowserSCP(master=frameRight, initpath='/root') # create Remote File Brwoser on frameLeft
    fbSCP  = FileBrowserSCP(master=frameRight , initType = 'Callbox',  initpath='/root',initRemoteIP='192.168.100.17')
    #fbSCP  = FileBrowserSCP(master=frameRight , initType = 'Callbox',  initpath='/root',initRemoteIP='10.0.0.185')


    # Create a new frame for the File Browser (UEsim)
    frmTabFiles_UEsim = ttk.Frame(notebook)
    frmTabFiles_UEsim .grid_columnconfigure(0, weight=0)
    frmTabFiles_UEsim .grid_rowconfigure(0, weight=0)
    notebook.add(frmTabFiles_UEsim , text="File Browser(UEsim)")

    frameLeft_UEsim , frameRight_UEsim  = create_frame_tabFiles_UEsim(frmTabFiles_UEsim)  # create three vertical frames on frmTabFiles
    fb_UEsim  = FileBrowser(master=frameLeft_UEsim , path='C:\\') # create Local File Brwoser on frameLeft
    fbSCP_UEsim  = FileBrowserSCP(master=frameRight_UEsim , initType = 'UEsim',  initpath='/root',initRemoteIP='192.168.100.15') 
    #fbSCP_UEsim  = FileBrowserSCP(master=frameRight_UEsim , initType = 'UEsim',  initpath='/root',initRemoteIP='10.0.0.35') 


    # Create a new frame for the Screen (Callbox)
    frmTabScreen_Callbox = ttk.Frame(notebook)
    frmTabScreen_Callbox.grid_columnconfigure(0, weight=0)
    frmTabScreen_Callbox.grid_rowconfigure(0, weight=0)
    notebook.add(frmTabScreen_Callbox, text="Screen(Callbox)")

    frameScreen_Callbox = create_frame_tabScreen_Callbox(frmTabScreen_Callbox)  # create three vertical frames on frmTabFiles
    screen_CallBox  = ScreenSSH(master=frameScreen_Callbox , initType = 'Callbox',  initpath='/root',initRemoteIP='192.168.100.17')
    #screen_CallBox  = ScreenSSH(master=frameScreen_Callbox , initType = 'Callbox',  initpath='/root',initRemoteIP='10.0.0.185')

    def is_frmTabScreen_Callbox_selected():
        selected_tab = notebook.select()
        return selected_tab == str(frmTabScreen_Callbox)
    
    def on_tab_changed(event):
        if is_frmTabScreen_Callbox_selected():
            print("frmTabScreen_Callbox is selected")
            screen_CallBox.stop_thread = False
            frameScreen_Callbox.update()
            if screen_CallBox.isInScreen : 
               screen_CallBox.connect()
               screen_CallBox.process_RunScreen() 
        else:  
            print("frmTabScreen_Callbox is Not selected")  
            screen_CallBox.stop_thread = True
            screen_CallBox.disconnect()
            

    notebook.bind("<<NotebookTabChanged>>", on_tab_changed)

    def on_destroy():
        screen_CallBox.stop_thread = True
        screen_CallBox.disconnect()
        root.destroy()
    
    #root.bind("<Destroy>", on_destroy)
    root.protocol("WM_DELETE_WINDOW", on_destroy)

    root.mainloop()


if __name__ == "__main__":
    main()


 # You can make this script as an executable file as follows
 # first you need to install
 #        pip install pyinstaller
 # pyinstaller --onefile ws_gui.py   